with Vstring_Type;
use Vstring_Type;

package Error_Log is

    procedure Log_Error (Msg : String);
    procedure Log_Error (Msg : E_String);
------------------------------------------------------------------------------
-- Log an error message using the local system conventions.  This indicates
-- that someting has gone actively wrong.
------------------------------------------------------------------------------

    procedure Log_Info (Msg : String);
    procedure Log_Info (Msg : E_String);
------------------------------------------------------------------------------
-- Log an informational message using the local system conventions.  This
-- indicates that someting "interesting" is/has happening/ed.
------------------------------------------------------------------------------

    procedure Log_State (Msg : String);
    procedure Log_State (Msg : E_String);
------------------------------------------------------------------------------
-- Log a program state message using the local system conventions.  This
-- indicates that the program is about to enter some major stage of processing.
------------------------------------------------------------------------------

    procedure Log_Cont (Msg : String);
    procedure Log_Cont (Msg : E_String);
------------------------------------------------------------------------------
-- Used to log continuation lines for any of the above kinds of messages.
------------------------------------------------------------------------------

end Error_Log;
