with Arithmetic;
use Arithmetic;
with Vstring_Type;
use Vstring_Type;

package Vstring_Equal is
------------------------------------------------------------------------------
-- VString Equality Tests
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

    function Equal (Vstr1 : Vstring_Data; Vstr2 : Vstring_Data) return Boolean;
    function Equal (Vstr1 : Vstring_Data; Vstr2 : Vstring)      return Boolean;
    function Equal (Vstr1 : Vstring; Vstr2 : Vstring_Data)      return Boolean;
    function Equal (Vstr1 : Vstring; Vstr2 : Vstring)           return Boolean;
    ----Check for equality (same Vstr.Length and same Vstr.Chars(1..Vstr.Length)
    --  contents).

    function Equal (Vstr1 : Vstring_Data; Vstr2 : E_String)  return Boolean;
    function Equal (Vstr1 : Vstring_Data; Vstr2 : Character) return Boolean;
    function Equal (Vstr1  : Vstring_Data;  
                    Vstr2  : Character;  
                    Copies : S_Natural)                      return Boolean;
    function Equal (Vstr1 : Vstring; Vstr2 : E_String)       return Boolean;
    function Equal (Vstr1 : Vstring; Vstr2 : Character)      return Boolean;
    function Equal (Vstr1  : Vstring;  
                    Vstr2  : Character;  
                    Copies : S_Natural)                      return Boolean;
    ----Check for equality between a Vstring and a string/character/N-characters.

    function Uc_Equal (Vstr1 : Vstring_Data;  
                       Vstr2 : Vstring_Data)                  return Boolean;
    function Uc_Equal (Vstr1 : Vstring_Data; Vstr2 : Vstring) return Boolean;
    function Uc_Equal (Vstr1 : Vstring; Vstr2 : Vstring_Data) return Boolean;
    function Uc_Equal (Vstr1 : Vstring; Vstr2 : Vstring)      return Boolean;
    ----Check for equality (same Vstr.Length and same Vstr.Chars(1..Vstr.Length)
    --  contents).

    function Uc_Equal (Vstr1 : Vstring_Data; Vstr2 : E_String)  return Boolean;
    function Uc_Equal (Vstr1 : Vstring_Data; Vstr2 : Character) return Boolean;
    function Uc_Equal (Vstr1  : Vstring_Data;  
                       Vstr2  : Character;  
                       Copies : S_Natural)                      return Boolean;
    function Uc_Equal (Vstr1 : Vstring; Vstr2 : E_String)       return Boolean;
    function Uc_Equal (Vstr1 : Vstring; Vstr2 : Character)      return Boolean;
    function Uc_Equal (Vstr1  : Vstring;  
                       Vstr2  : Character;  
                       Copies : S_Natural)                      return Boolean;
    ----Check for equality between a Vstring and a string/character/N-characters.

    function Equal_Prefix    (Vstr1 : Vstring_Data;  
                              Vstr2 : E_String) return Boolean;
    function Equal_Prefix    (Vstr1 : Vstring;  
                              Vstr2 : E_String) return Boolean;
    function Uc_Equal_Prefix (Vstr1 : Vstring_Data;  
                              Vstr2 : E_String) return Boolean;
    function Uc_Equal_Prefix (Vstr1 : Vstring;  
                              Vstr2 : E_String) return Boolean;
    ----Check for equality between the first N characters of Vstr1 with the
    --  full length of Vstr2.  N = Vstr2.Length.

end Vstring_Equal;
