with Arithmetic;
use Arithmetic;
with Vstring_Type;
use Vstring_Type;

package Vstring_Heap is
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

    function New_Vstring (Maximum_Length : S_Natural) return Vstring;
    ----Called to allocate a new heap-based Vstring.
    --  Maximum_Length - The contents of the string can never be longer than
    --                   this number of characters.

    procedure Free_Vstring (Vstr : in out Vstring);
    ----Called to deallocate a heap-based Vstring.

    procedure Resize_Vstring (Vstr : in out Vstring; New_Size : S_Natural);
    ----Called to change the size of a Vstring.  We return a Vstring of the
    --  specified size (if different) and we copy as much of the contents of
    --  the old Vstring into the new as will fit.

end Vstring_Heap;
