with Text_Io;

with Arithmetic;
use Arithmetic;
with Vstring_Type;
use Vstring_Type;

package Vstring_Io is
------------------------------------------------------------------------------
-- Vstring I/O
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

    procedure Get (File        :        Text_Io.File_Type;  
                   Line        : in out Vstring_Data;
                   End_Of_Line : in out Boolean;
                   End_Of_Page : in out Boolean;
                   End_Of_File : in out Boolean);
    procedure Get (File        :        Text_Io.File_Type;  
                   Line        :        Vstring;
                   End_Of_Line : in out Boolean;
                   End_Of_Page : in out Boolean;
                   End_Of_File : in out Boolean);
    ----Just line Text_Io.Get.  Get all or part of a line.
    --  End_Of_Line iff Item contains the end of line (possibly null)
    --  End_Of_Page iff End_Of_Line and this is the last line of the page
    --  End_Of_File iff End_Of_Page and this is the last page of the file
    --
    --  The intent if for each call to return as many characters from the
    --  line as fit, but Line.Length /= Line.Maximum_Length doesn't imply
    --  End_Of_Line.

    procedure Get_Resize (File          :        Text_Io.File_Type;  
                          Line          : in out Vstring;
                          Resize_Amount :        S_Positive;  
                          End_Of_Line   : in out Boolean;
                          End_Of_Page   : in out Boolean;
                          End_Of_File   : in out Boolean);
    ----Just like Get above except that Line will be continually resized
    --  by Resize_Amount's until we can fit in an entire line (or until we
    --  hit End_Of_Page/File).

    procedure Put      (Vstr : Vstring_Data);
    procedure Put      (File : Text_Io.File_Type; Vstr : Vstring_Data);
    procedure Put_Line (Vstr : Vstring_Data);
    procedure Put_Line (File : Text_Io.File_Type; Vstr : Vstring_Data);
    procedure Put      (Vstr : Vstring);
    procedure Put      (File : Text_Io.File_Type; Vstr : Vstring);
    procedure Put_Line (Vstr : Vstring);
    procedure Put_Line (File : Text_Io.File_Type; Vstr : Vstring);
    ----Do output of the contents of a Vstring.

end Vstring_Io;
