with Arithmetic;
use Arithmetic;

package Vstring_Type is
------------------------------------------------------------------------------
-- VString - Variable length, fixed maximum length, strings.
------------------------------------------------------------------------------
-- Copyright 1988 - 1991 by Rational, Santa Clara, California.
--
--                  All Rights Reserved.
--
-- Permission to use, copy, modify, and distribute this software and its
-- documentation for any purpose and without fee is hereby granted,
-- provided that the above copyright notice(s) appear in all copies and that
-- both that copyright notice(s) and this permission notice appear in
-- supporting documentation, and that the name of Rational not be used in
-- advertising or publicity pertaining to distribution of the software
-- without specific, written prior permission.
--
-- Rational disclaims all warranties with regard to this software, including
-- all implied warranties of merchantability and fitness, in no event shall
-- Rational be liable for any special, indirect or consequential damages or
-- any damages whatsoever resulting from loss of use, data or profits, whether
-- in an action of contract, negligence or other tortious action, arising out
-- of or in connection with the use or performance of this software.
------------------------------------------------------------------------------

    type E_String         is array (S_Positive range <>) of Character;
    type E_String_Pointer is access E_String;

    type E_String_Array is array (S_Positive range <>) of E_String_Pointer;
    type E_String_List  is access E_String_Array;

    function To_String (Estr : E_String) return String;
------------------------------------------------------------------------------
-- Changes the E_String into a normal Ada string.  Truncates the E_String,
-- if necessary, in order to create a maximally sized Ada String.  (This is
-- in the case where Integer'Size is 16 bits.)
------------------------------------------------------------------------------

    type Vstring_Data (Maximum_Length : S_Natural) is
    ----Version of string for stack and array allocation.
        record
            Length : S_Natural := 0;                 -- Current string length
            Chars  : E_String (1 .. Maximum_Length); -- Current string contents
        end record;

    type Vstring is access Vstring_Data;
    ----Version of string for heap allocation.

    None_Vstring : constant Vstring := null;

    type Vstring_Array is array (S_Positive range <>) of Vstring;
    type Vstring_List  is access Vstring_Array;

----VStrings hold 0..N characters.  N is determined when the string is
--  allocated.
--
--  Data in VStrings consists of Chars(1..N).  Char(1) is valid if the length
--  of the VString is in the 1..N range.  Char(2) is valid if the length of
--  the VString is in the 2..N range.  Etc.
--
--  Length is always in the 0..Maximum_Length range.

end Vstring_Type;
