with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Event;  
use Xlbt_Event;  

package Draw is  
------------------------------------------------------------------------------  
-- Dragon - a version of Mah-Jongg for X Windows  
--  
-- Author: Gary E. Barnes        May 1989  
--  
-- Draw - Deals with the Mah-Jongg board.  Setup and drawing.  
------------------------------------------------------------------------------  
-- 05/30/90 GEB  - Translate to Ada  
------------------------------------------------------------------------------  

    procedure Board_Configure (Event : X_Configure_Notify_Event);  
------------------------------------------------------------------------------  
-- Called when the Board receives a ConfigureNotify event.  
------------------------------------------------------------------------------  

    procedure Board_Expose;  
------------------------------------------------------------------------------  
-- Called when the Board receives an Expose event.  
------------------------------------------------------------------------------  

    procedure Board_Setup;  
------------------------------------------------------------------------------  
-- Called to set up and create the Board widget.  
------------------------------------------------------------------------------  

    procedure Draw_All_Tiles;  
------------------------------------------------------------------------------  
-- Draws all visible tiles.  
------------------------------------------------------------------------------  

    procedure Hilite_Tile (Row : S_Short;  
                           Col : S_Short);  
------------------------------------------------------------------------------  
--   row - Specifies the row of the tile to hilite  
--   col - specifies the column of the tile to hilite  
--  
-- Called to hilite a tile face.  
------------------------------------------------------------------------------  

    procedure Show_Samples (Event : X_Button_Press_Event);  
------------------------------------------------------------------------------  
-- Called when the Samples button is presses.  Display or un-display the sample  
-- tiles.  
------------------------------------------------------------------------------  

end Draw;  

