.TH DRAGON 1 "26 June 1990" "X Version 11R3"
.SH NAME
dragon \- Mah-Jongg game
.SH SYNOPSIS
.B dragon
.SH DESCRIPTION
\fIDragon\fP plays a version of the game of Mah-Jongg.

Mah-Jongg is played with a set of tiles.  The tiles are set out in a
particular pattern and the object of the game is to eliminate all of
the tiles.  \fIDragon\fP plays with the tile pattern known as "The
Dragon".  This pattern has 5 levels of tiles.  From above, this
pattern somewhat resembles a sleeping dragon.

Tiles are removed from the game two at a time.  The two tiles removed
must "match" and they must both be "free".

A tile is "free" if on the left or on the right side there is no tile
that is on the same stacking level as this tile.  There may be tiles
that are at a lower level than this tile but not one at the same or
higher level.  To select a free tile for removal just click on it.
\fIDragon\fP will refuse to select a tile that is not free.  To remove
a pair of tiles simply double-click on one of the tiles.  You have the
option of selecting one tile and then double-clicking on the second or
else selecting both tiles and then double-clicking upon either tile.

Two tiles match if a) they both have the same picture upon their
faces, b) they are both flowers, or c) if they are both seasons.

There are seven types of tile.

Flowers - There are four tiles that represent flowers.  These are the
Orchid, the Plum, the Mum, and the Bamboo tiles.  Any two flowers match.

Seasons - There are four tiles that represent the four seasons.  These
are the Spring, Summer, Autumn, and Winter tiles.  Any two seasons match.

Dragons - There are three types of dragons and there are four each of
the dragons.  There is the Red dragon, the White dragon, and the Green
dragon.  Only two dragons of the same type match each other.

Winds - There are four each of the four winds.  These are the East,
West, North, and South tiles.  Only two winds from the same direction
match each other.

Bams, Dots, and Craks - These tiles are numbered 1 through 9.  There
are four each of each numbered tile.  Only two tiles of the same type
with the same number match each other.

.SH OPTIONS
.TP 8
.B \-help
This produces a verbose message describing the command line options.
.TP 8
.B \-display display:server.screen
Use this option to tell dragon what display to use.  Uses the DISPLAY
environment variable by default.
.SH MOUSE BUTTONS
Click button 1 on any tile to select it.  Click on any menu button to activate
it.

Click button 2 to obtain a (next) hint on a possible move.  See the Hint menu
button below for more information.

Click button 3 to remove two selected tiles from the game.
.SH MENU BUTTONS
There are several buttons visible in \fIdragon's\fP window and there
are two sets of buttons.  The inital set includes:
.TP 8
.B "New Game"
Press this button to reshuffle the tiles and start a new game.
.TP 8
.B "Restart"
Press this button to restart the current game.  This gives you a
chance to try again.
.TP 8
.B "Save"
Press this button to save the current game into the file
$HOME/.dragon-save.  The current game is saved at the current point
for later resumption.
.TP 8
.B "Other"
Press this button to get to the other set of buttons.
.TP 8
.B "Hint"
This button can be used in two ways.  First, if you are stuck for a
move then just press this button repeatedly and \fIdragon\fP will show
successive possible moves.  Of course, there may not be any.  Second,
if you want to remove a particular tile but you cannot see any
matching free tiles then select the tile and then press this button to
see if \fIdragon\fP agrees with you that there aren't any matching
free tiles.
.TP 8
.B "Restore"
Press this button to read the $HOME/.dragon-save file and to resume a
saved game.
.TP 8
.B "Quit"
Press this button to exit the game.
.PP
The other set of buttons include:
.TP 8
.B "Redraw"
Press this to cause the board to be redrawn.
.TP 8
.B "Sides"
Press this repeatedly to cycle through the available set of drawing
options for the tiles.
.TP8
.B "Samples"
Press this to display the full set of tiles.  Press it again to get back to
the game.
.TP 8
.B "Other"
Press this to get back to the first set of buttons.
.TP 8
.B "Cheat"
Press this button to toggle Cheating mode.  When this is turned on you
can remove any two arbitrary tiles.  Don't cheat!
.TP 8
.B "Sync"
Press this button to turn on synchronous mode.  This makes
\fIdragon\fP synchronize everything with the X Server; it is typically
used only for debugging.
.SH "SEE ALSO"
X(1)
.SH BUGS
.LP
No known bugs.  Send bug reports to geb@rational.com.
.SH COPYRIGHT
None; have fun.
.SH AUTHOR
Gary E. Barnes (Rational; geb@rational.com)
.br
