with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_String7;  
use Xlbt_String7;  

with Xlbp_Display;  
use Xlbp_Display;  

package Ico_Polyinfo is  
------------------------------------------------------------------------------  
-- Derived from: polyinfo.h  
-- This is the description of one polyhedron file  
------------------------------------------------------------------------------  
--/* $Header: ico.c,v 1.4 88/02/09 13:15:08 jim Exp $ */  
--/***********************************************************  
-- Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,  
-- and the Massachusetts Institute of Technology, Cambridge, Massachusetts.  
--  
--                         All Rights Reserved  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice appear in all copies and that  
-- both that copyright notice and this permission notice appear in  
-- supporting documentation, and that the names of Digital or MIT not be  
-- used in advertising or publicity pertaining to distribution of the  
-- software without specific, written prior permission.  
--  
-- DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING  
-- ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL  
-- DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR  
-- ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,  
-- WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,  
-- ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS  
-- SOFTWARE.  
------------------------------------------------------------------------------  

--    X_Lib : X_Library := New_X_Library (True);  -- geb DEBUG DEBUG  
--    X_Lib  : X_Library              := New_X_Library (False);  

    Max_Verts : constant := 120;  
    ----Great rhombicosidodecahedron has 120 vertices  
    Max_Nv    : constant := Max_Verts;  
    Max_Faces : constant := 30;  
    ----(hexakis icosahedron has 120 faces)  
    Max_Edges : constant := 180;  
    ----Great rhombicosidodecahedron has 180 edges  
    Max_Edges_Per_Poly : constant := 20;  

    type Point_3d is  
        record  
            X : Float;  
            Y : Float;  
            Z : Float;  
        end record;  

    type Point_3d_Array    is array (S_Natural range <>) of Point_3d;  
    type Point_3d_List     is access Point_3d_Array;  
    type Point_3d_Array_2d is array (Boolean) of  
                                 Point_3d_Array (0 .. Max_Nv - 1);  
    type S_Natural_Array   is array (S_Natural range <>) of S_Natural;  
    type S_Natural_List    is access S_Natural_Array;  

----Structure of the include files which define the polyhedra  

    type Poly_Info is  
        record  
            Long_Name  : X_String7_Pointer;  -- long name of object  
            Short_Name : X_String7_Pointer;  -- short name of object  
            Dual       : X_String7_Pointer;  -- long name of dual  
            Num_Verts  : S_Natural;         -- number of vertices  
            Num_Edges  : S_Natural;         -- number of edges  
            Num_Faces  : S_Natural;         -- number of faces  
            V          : Point_3d_List;     -- the vertices  
            F          : S_Natural_List;    -- the faces  
        end record;  

end Ico_Polyinfo;  

