.TH ICO 1 "Release 4" "X Version 11"
.SH NAME
ico \- animate an icosahedron or other polyhedron
.SH SYNOPSIS
.B ico
[-display display] [-geometry geometry]
[-r] [-d pattern] [-i] [-dbl] [-faces] [-noedges]
[-sleep n] [-obj object] [-objhelp] [-colors color-list]
.SH DESCRIPTION
.I Ico
displays a wire-frame rotating polyhedron, with hidden lines removed,
or a solid-fill polyhedron with hidden faces removed.
There are a number of different polyhedra available;
adding a new polyhedron to the program is quite simple.
.SH OPTIONS
.TP
.B -r
Display on the root window instead of creating a new window.
.TP
.B -d pattern
Specify a bit pattern for drawing dashed lines for wire frames.
.TP
.B -i
Use inverted colors for wire frames.
.TP
.B -dbl
Use double buffering on the display.
This works for either wire frame or solid fill drawings.
For solid fill drawings, using this switch results in substantially
smoother movement.
Note that this requires twice as many bit planes as without double buffering.
Since some colors are typically allocated by other programs,
most eight-bit-plane displays will probably be limited to eight colors
when using double buffering.
.TP
.B -faces
Draw filled faces instead of wire frames.
.TP
.B -noedges
Don't draw the wire frames.
Typically used only when -faces is used.
.TP
.B -sleep \fIn\fP
Sleep n seconds between each move of the object.
.TP
.B -obj \fIobject\fP
Specify what object to draw.
If no object is specified, an icosahedron is drawn.
.TP
.B -objhelp
Print out a list of the available objects, along with information
about each object.
.TP
.B -colors \fIcolor color ...\fP
Specify what colors should be used to draw the filled faces of the object.
If less colors than faces are given, the colors are reused.
.SH ADDING POLYHEDRA
.LP
If you have the source to ico, it is very easy to add more polyhedra.
Each polyhedron is defined in an Ada unit by the name of Ico_ObjXxxx,
where XXX is something related to the name of the polyhedron.
The contents of the Ada is defined in the unit Ico_Polyinfo.
Look at the unit Ico_Objcube to see an example object unit
should contain, then create your own unit in that style.
.LP

After making the new Ico_ObjXxxx unit (or copying in a new one from elsewhere),
edit the Ico_Main unit body and add your new polyhedron to the Polys list.
Then modify the filename list in the Imakefile, do a "make Makefile" and
then a "make all" to compile your new Ico program.
.SH "SEE ALSO"
X(1)
.SH BUGS
.LP
A separate color cell is allocated for each name in the -colors list,
even when the same name may be specified twice.
.SH COPYRIGHT
Copyright 1988, Massachusetts Institute of Technology.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
