with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package Puz_Puzzle is  

    type Direction       is (Left, Right, Up, Down, None);  
    type Direction_Array is array (S_Natural range <>) of Direction;  
    type Direction_List  is access Direction_Array;  

    type S_Long_2d        is array (S_Natural range <>) of S_Long;  
    type S_Long_2d_Access is access S_Long_2d;  

    Output_Logging : Boolean   := False;  
    Position       : S_Long_2d_Access;  
    Puzzle_Size    : S_Natural := 4;  
    Puzzle_Width   : S_Natural := 4;  
    Puzzle_Height  : S_Natural := 4;  
    Space_X        : S_Long;          -- location of space in  
    Space_Y        : S_Long;          --  the position matrix  

    procedure Initialize;  
    procedure Move_Space_To (Loc : S_Natural);  
    procedure Scramble;  
    procedure Abort_Solving;  
    function  Solving_Status return Boolean;  
    procedure Solve;  

    function Random return S_Natural;  

end Puz_Puzzle;  

