with System;  

package Xlbmt_Parameters is  
------------------------------------------------------------------------------  
-- X Library Machine Types  
--  
-- Xlbmt_Parameters - Machine/Compiler specific X Library parameters.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  
--
--/ if R1000 then  
  
    X_Output_Buffer_Size : constant := 4096 * 4;  
    -- Maximum X output buffer size; in bytes.  Our code assumes that this  
    -- is always a multiple of 4 and greater than 256+32.  You can make it  
    -- as big as you want as long as it is <= 16K.  16K is the minimum  
    -- guaranteed size.  All servers will accepts a minimum of 16K.  
    -- If you make it > 16K then it will not work for some servers.  
  
    X_Input_Buffer_Size : constant := 1024 * 4;  
    -- Maximum X input buffer size; in bytes.  Our code assumes that this  
    -- is a multiple of 4 and it must be at least 32.  You can make it as  
    -- big as you want.  Larger values work better when "large" replies are  
    -- expected.  
  
    X_Max_Q_Free : constant := 100;  
    -- Maximum number of free events on a single display queue.  
  
    X_Error_Database : constant String := "!Tools.X_Windows.X_Data.X_Error_DB";  
  
    X_Option_File : constant String := "X11_defaults";  
    -- Name of user default resources file in his home directory.  
  
    X_Environment_File : constant String := "X11_defaults_";  
    -- First part of the name of a per-host user default resources file  
    -- in his home directory.  E.g. if current host is Bozo then the  
    -- file is "!User.Somebody.X11_Defaults_Bozo".  
  
    X_Key_Sym_Db_File : constant String :=  
       "!Tools.X_Windows.X_Data.X_Key_Sym_Db";  
    -- File containing a list of site-specific key symbol resources.  
    -- Each line of the file consists of "name : code".  Where code is  
    -- a hex number, e.g. "NewKey : FA32".  
    -- Comments and blank lines may be included.  Comments lines have '!' as  
    -- the first non-blank character.  
  
    X_Var_Xenvironment : constant String := "XENVIRONMENT";  
    ----Environment variable called "XENVIRONMENT" on Unix.  
  
--/ elsif Cdf_Hpux then  
 
    X_Output_Buffer_Size : constant := 4096;  
    -- Maximum X output buffer size; in bytes.  Our code assumes that this  
    -- is always a multiple of 4 and greater than 256+32.  You can make it  
    -- as big as you want as long as it is <= 16K.  16K is the minimum  
    -- guaranteed size.  All servers will accepts a minimum of 16K.  
    -- If you make it > 16K then it will not work for some servers.  
 
    X_Input_Buffer_Size : constant := 1024;  
    -- Maximum X input buffer size; in bytes.  Our code assumes that this  
    -- is a multiple of 4 and it must be at least 32.  You can make it as  
    -- big as you want.  Larger values work better when "large" replies are  
    -- expected.  
 
    X_Max_Q_Free : constant := 100;  
    -- Maximum number of free events on a single display queue.  
 
    X_Error_Database : constant String := "/usr/lib/X11/ada/X_Error_Db";  
 
    X_Option_File : constant String := ".Xdefaults";  
    -- Name of user default resources file in his home directory.  
 
    X_Environment_File : constant String := ".Xdefaults_";  
    -- First part of the name of a per-host user default resources file  
    -- in his home directory.  E.g. if current host is Bozo then the  
    -- file is "~Somebody/.Xdefaults_Bozo".  
 
    X_Key_Sym_Db_File : constant String := "/usr/lib/X11/ada/X_Key_Sym_Db";  
    -- File containing a list of site-specific key symbol resources.  
    -- Each line of the file consists of "name : code".  Where code is  
    -- a hex number, e.g. "NewKey : FA32".  
    -- Comments and blank lines may be included.  Comments lines have '!' as  
    -- the first non-blank character.  
 
    X_Var_Xenvironment : constant String := "XENVIRONMENT";  
    ----Environment variable called "XENVIRONMENT" on Unix.  
 
--/ elsif TeleGen2 and then Unix then  
 
   X_Output_Buffer_Size : constant := 4096;  
   -- Maximum X output buffer size; in bytes.  Our code assumes that this  
   -- is always a multiple of 4 and greater than 256+32.  You can make it  
   -- as big as you want as long as it is <= 16K.  16K is the minimum  
   -- guaranteed size.  All servers will accepts a minimum of 16K.  
   -- If you make it > 16K then it will not work for some servers.  
 
   X_Input_Buffer_Size : constant := 1024;  
   -- Maximum X input buffer size; in bytes.  Our code assumes that this  
   -- is a multiple of 4 and it must be at least 32.  You can make it as  
   -- big as you want.  Larger values work better when "large" replies are  
   -- expected.  
 
   X_Max_Q_Free : constant := 100;  
   -- Maximum number of free events on a single display queue.  
 
   X_Error_Database : constant String :=  
                           "/usr/lib/X11/ada/X_Error_Db";  
 
   X_Option_File : constant String := ".Xdefaults";  
   -- Name of user default resources file in his home directory.  
 
   X_Environment_File : constant String := ".Xdefaults_";  
   -- First part of the name of a per-host user default resources file  
   -- in his home directory.  E.g. if current host is Bozo then the  
   -- file is "~Somebody/.Xdefaults_Bozo".  
 
   X_Key_Sym_Db_File : constant String :=  
                           "/usr/lib/X11/ada/X_Key_Sym_Db";  
   -- File containing a list of site-specific key symbol resources.  
   -- Each line of the file consists of "name : code".  Where code is  
   -- a hex number, e.g. "NewKey : FA32".  
   -- Comments and blank lines may be included.  Comments lines have '!' as  
   -- the first non-blank character.  
 
   X_Var_Xenvironment : constant String := "XENVIRONMENT";  
   ----Environment variable called "XENVIRONMENT" on Unix.  
 
--/ else  
 
   X_Output_Buffer_Size : constant := 4096;  
   -- Maximum X output buffer size; in bytes.  Our code assumes that this  
   -- is always a multiple of 4 and greater than 256+32.  You can make it  
   -- as big as you want as long as it is <= 16K.  16K is the minimum  
   -- guaranteed size.  All servers will accepts a minimum of 16K.  
   -- If you make it > 16K then it will not work for some servers.  
 
   X_Input_Buffer_Size : constant := 1024;  
   -- Maximum X input buffer size; in bytes.  Our code assumes that this  
   -- is a multiple of 4 and it must be at least 32.  You can make it as  
   -- big as you want.  Larger values work better when "large" replies are  
   -- expected.  
 
   X_Max_Q_Free : constant := 100;  
   -- Maximum number of free events on a single display queue.  
 
   X_Error_Database : constant String := "!Machine.X_Data.X_Error_Db";  
 
   X_Option_File : constant String := "X11_defaults";  
   -- Name of user default resources file in his home directory.  
 
   X_Environment_File : constant String := "X11_defaults_";  
   -- First part of the name of a per-host user default resources file  
   -- in his home directory.  E.g. if current host is Bozo then the  
   -- file is "!User.Somebody.X11_Defaults_Bozo".  
 
   X_Key_Sym_Db_File : constant String := "!Machine.X_Data.X_Key_Sym_Db";  
   -- File containing a list of site-specific key symbol resources.  
   -- Each line of the file consists of "name : code".  Where code is  
   -- a hex number, e.g. "NewKey : FA32".  
   -- Comments and blank lines may be included.  Comments lines have '!' as  
   -- the first non-blank character.  
 
   X_Var_Xenvironment : constant String := "XENVIRONMENT";  
   ----Environment variable called "XENVIRONMENT" on Unix.  
 
--/ end if;  

    X_Cursor_Font_Name : constant String := "cursor"; -- standard cursor fonts  

    X_Protocol          : constant := 11;   -- current protocol version  
    X_Protocol_Revision : constant := 0;    -- current minor version  

------------------------------------------------------------------------------  
-- Constants for record representation specifications.  
--  
-- These are intended to be "machine independent" in the sense that they  
-- always mean what the X protocol needs them to mean.  The exact values  
-- change from machine to machine.  
--  
-- The "1st" byte of a 32-bit word is always the first byte of that same  
-- storage when that storage is treated as an array of bytes instead of as a  
-- 32-bit value.  I.e. it is the 0'th byte in the machine addressing sense.  
--  
-- Bits within a record representation clause are numbered in some order.  
-- That order is an arbitrary decision made by the compiler implementor.  It  
-- may or may not be related to any bit addressing capability provided by the  
-- hardware.  Read your compiler manual in order to determine whether bit 0  
-- in a record field's representation is the "left" (sign) bit or the "right"  
-- (even/odd) bit of the field.  
------------------------------------------------------------------------------  

    X_Word : constant := 32 / System.Storage_Unit;  
    -- Number of storage units in 32-bit word.  

--/ if Record_Rep_Storage_Unit_8 then  

    X_Byte0a : constant := 0;    -- 1st byte in a 32-bit word  
    X_Byte0b : constant := 7;  
    X_Byte1a : constant := 8;    -- 2nd byte in a 32-bit word  
    X_Byte1b : constant := 15;  
    X_Byte2a : constant := 16;   -- 3rd byte in a 32-bit word  
    X_Byte2b : constant := 23;  
    X_Byte3a : constant := 24;   -- 4th byte in a 32-bit word  
    X_Byte3b : constant := 31;  

    X_Half0a : constant := 0;    -- 1st half word in a 32-bit word  
    X_Half0b : constant := 15;  
    X_Half1a : constant := 16;   -- 2nd half word in a 32-bit word  
    X_Half1b : constant := 31;  

    X_Word0a : constant := 0;    -- Full 32-bit word  
    X_Word0b : constant := 31;  

--/ elsif Record_Rep_Storage_Unit_16 then  
 
    X_Byte0a : constant := 8;   -- 1st byte in a 32-bit word  
    X_Byte0b : constant := 15;  
    X_Byte1a : constant := 0;   -- 2nd byte in a 32-bit word  
    X_Byte1b : constant := 7;  
    X_Byte2a : constant := 24;    -- 3rd byte in a 32-bit word  
    X_Byte2b : constant := 31;  
    X_Byte3a : constant := 16;    -- 4th byte in a 32-bit word  
    X_Byte3b : constant := 23;  
 
    X_Half0a : constant := 0;   -- 1st half word in a 32-bit word  
    X_Half0b : constant := 15;  
    X_Half1a : constant := 16;    -- 2nd half word in a 32-bit word  
    X_Half1b : constant := 31;  
 
    X_Word0a : constant := 0;    -- Full 32-bit word  
    X_Word0b : constant := 31;  
 
--/ elsif Record_Rep_Storage_Unit_32 then  
 
    X_Byte0a : constant := 24;   -- 1st byte in a 32-bit word  
    X_Byte0b : constant := 31;  
    X_Byte1a : constant := 16;   -- 2nd byte in a 32-bit word  
    X_Byte1b : constant := 23;  
    X_Byte2a : constant := 8;    -- 3rd byte in a 32-bit word  
    X_Byte2b : constant := 15;  
    X_Byte3a : constant := 0;    -- 4th byte in a 32-bit word  
    X_Byte3b : constant := 7;  
 
    X_Half0a : constant := 16;   -- 1st half word in a 32-bit word  
    X_Half0b : constant := 31;  
    X_Half1a : constant := 0;    -- 2nd half word in a 32-bit word  
    X_Half1b : constant := 15;  
 
    X_Word0a : constant := 0;    -- Full 32-bit word  
    X_Word0b : constant := 31;  
 
--/ end if; -- Record_Rep_Storage_Unit_??  

end Xlbmt_Parameters;  

