--/ if TeleGen2 and then Unix then  
with Unix_Implementation_Types;         -- Unix String Types  
use Unix_Implementation_Types;  
 
with System;  
--/ end if;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

package body Xlbmt_Transport_Defs is  
------------------------------------------------------------------------------  
-- X Library Machine Network Transport Types  
--  
-- Xlbmt_Transport_Defs - Machine/Compiler dependent network interface types.  
------------------------------------------------------------------------------  
-- Copyright 1990 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
--/ if Unix then  
 
    procedure Fd_Clr (Fds : out Fd_Set_Rec) is  
        ----Clear the set.  
    begin  
 
        Fds := (others => 0);  
 
    end Fd_Clr;  
 
--/ end if; -- Unix  

--
--/ if Unix then  
 
    procedure Fd_Set (Fds : in out Fd_Set_Rec; Fd : Connection_Id) is  
        ----Set a bit in the set.  
    begin  
 
        Fds (S_Natural (Fd / 32)) := 2 ** Natural (Fd rem 32);  
 
    end Fd_Set;  
 
--/ end if; -- Unix  

--
end Xlbmt_Transport_Defs;  

