with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_Font3;  
use Xlbt_Font3;  
with Xlbt_Key3;  
use Xlbt_Key3;  
with Xlbt_Keyboard3;  
use Xlbt_Keyboard3;  
with Xlbt_Misc;  
use Xlbt_Misc;  
with Xlbt_Pointer;  
use Xlbt_Pointer;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_String16;  
use Xlbt_String16;  

with Xlbmp_Generic_Converters;  
use Xlbmp_Generic_Converters;  

package Xlbip_Base_Converters is  
------------------------------------------------------------------------------  
-- X Library Internal Basic Converters  
--  
-- Xlbip_Base_Converters - Protocol converters for basic types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Atom  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Atom,  
                                 S_Natural,  
                                 X_Atom_Array);  

    procedure To_Raw is new Convert_Array_To_Raw (X_Atom,  
                                                  S_Natural,  
                                                  X_Atom_Array);  

------------------------------------------------------------------------------  
-- X_Char_Struct  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Char_Struct);  


--/ if not TeleGen2_2d_Bug then  
  
    procedure From_Raw is  
       new Convert_Raw_To_2d_Array (X_Char_Struct,  
                                    U_Char,  
                                    U_Char,  
                                    X_Char_Struct_Array_2d);  
--/ else  
 
    procedure From_Raw is  
       new Convert_Raw_To_2d_Array (X_Char_Struct,  
                                    TeleGen2_2d_Bug,  
                                    U_Char,  
                                    X_Char_Struct_Array_2d);  
 
--/ end if;  

------------------------------------------------------------------------------  
-- X_Colormap  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Colormap,  
                                 S_Natural,  
                                 X_Colormap_Array);  

------------------------------------------------------------------------------  
-- X_Event_Mask  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Event_Mask);  

------------------------------------------------------------------------------  
-- X_Font_Prop  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Font_Prop,  
                                 S_Natural,  
                                 X_Font_Prop_Array);  

------------------------------------------------------------------------------  
-- X_Id  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Id);  

------------------------------------------------------------------------------  
-- X_Key_Code  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Key_Code,  
                                 S_Natural,  
                                 X_Key_Code_Array);  

    procedure To_Raw is new Convert_Array_To_Raw (X_Key_Code,  
                                                  S_Natural,  
                                                  X_Key_Code_Array);  

------------------------------------------------------------------------------  
-- X_Key_Sym_Array_2d  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Key_Sym);  

    procedure From_Raw is  
       new Convert_Raw_To_Private (X_Key_Sym);  

--/ if not TeleGen2_2d_Bug then  
  
    procedure From_Raw is  
       new Convert_Raw_To_2d_Array (X_Key_Sym,  
                                    X_Key_Code,  
                                    U_Char,  
                                    X_Key_Sym_Array_2d);  
  
--/ else  
 
    procedure From_Raw is  
       new Convert_Raw_To_2d_Array (X_Key_Sym,  
                                    Telegen2_2d_Bug,  
                                    U_Char,  
                                    X_Key_Sym_Array_2d);  
 
--/ end if;  

--/ if TeleGen2_2d_Bug then  
 
    procedure To_Raw is  
       new Convert_2d_Array_To_Raw (X_Key_Sym,  
                                    Telegen2_2d_Bug,  
                                    U_Char,  
                                    X_Key_Sym_Array_2d);  
 
--/ else  
  
    procedure To_Raw is new Convert_2d_Array_To_Raw  
                               (X_Key_Sym, X_Key_Code,  
                                U_Char, X_Key_Sym_Array_2d);  
  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Led_Bits  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Led_Bits);  

------------------------------------------------------------------------------  
-- X_Modifier_Key_Code_Array  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Array_To_Raw (X_Modifier_Key_Code_Sub_Array,  
                                 S_Natural,  
                                 X_Modifier_Key_Code_Array);  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Modifier_Key_Code_Sub_Array,  
                                 S_Natural,  
                                 X_Modifier_Key_Code_Array);  

------------------------------------------------------------------------------  
-- X_Pixel  
------------------------------------------------------------------------------  

    procedure To_Raw is new Convert_Array_To_Raw (X_Pixel,  
                                                  S_Natural,  
                                                  X_Pixel_Array);  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Pixel,  
                                 S_Natural,  
                                 X_Pixel_Array);  

------------------------------------------------------------------------------  
-- X_Plane_Mask  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Discrete_To_Raw (X_Plane_Mask);  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Plane_Mask,  
                                 S_Natural,  
                                 X_Plane_Mask_Array);  

-- ------------------------------------------------------------------------------  
-- -- String  
-- ------------------------------------------------------------------------------  
--  
--     type X_Raw_Character_Array is array (X_Raw_Data) of Character;  
--  
--     procedure To_Raw (Raw : out X_Raw_Data_Array;  
--                       Str :     String);  
--     ----Take a String and return the corresponding X_Raw_Data_Array.  
--  
--     procedure From_Raw (Str : out String;  
--                         Raw :     X_Raw_Data_Array);  
--     ----Take a X_Raw_Data_Array and return the corresponding String.  Chops each  
--     --  raw datum down to 7 bits as the conversion is made.  
--  
--     procedure From_Raw (Str   : out String;  
--                         Raw   :     X_Raw_Data_Array;  
--                         Trans :     X_Raw_Character_Array);  
--     ----Take a X_Raw_Data_Array and translate each character in it into a 7-bit  
--     --  character and return the translated string.  
--  
------------------------------------------------------------------------------  
-- X_String  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Character,  
                                 S_Natural,  
                                 X_String);  

    procedure To_Raw is  
       new Convert_Array_To_Raw (X_Character,  
                                 S_Natural,  
                                 X_String);  

------------------------------------------------------------------------------  
-- X_String16  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Character16,  
                                 S_Natural,  
                                 X_String16);  

    procedure To_Raw is new Convert_Array_To_Raw (X_Character16,  
                                                  S_Natural,  
                                                  X_String16);  

------------------------------------------------------------------------------  
-- X_Text_Elt  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Text_Elt);  

------------------------------------------------------------------------------  
-- X_Time_Coord_Array  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Time_Coord,  
                                 S_Natural,  
                                 X_Time_Coord_Array);  

------------------------------------------------------------------------------  
-- X_Window  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (X_Window,  
                                 S_Natural,  
                                 X_Window_Array);  

------------------------------------------------------------------------------  
-- S_Long  
------------------------------------------------------------------------------  

    procedure To_Raw is  
       new Convert_Discrete_To_Raw (S_Long);  


------------------------------------------------------------------------------  
-- U_Char  
------------------------------------------------------------------------------  

    procedure From_Raw is  
       new Convert_Raw_To_Array (U_Char,  
                                 S_Natural,  
                                 U_Char_Array);  

    procedure To_Raw is new Convert_Array_To_Raw (U_Char,  
                                                  S_Natural,  
                                                  U_Char_Array);  

end Xlbip_Base_Converters;  

