with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Error;  
use Xlbt_Error;  
with Xlbt_Rm;  
use Xlbt_Rm;  
with Xlbt_String;  
use Xlbt_String;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

package Xlbip_Default_Proc_Vars is  
------------------------------------------------------------------------------  
-- X Library Internal Default Procedure Variable Values  
--  
-- Xlbip_Default_Proc_Vars - Default routines for various X_Display functions  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Default routines for normal and I/O errors.  
------------------------------------------------------------------------------  

    procedure Default_X_Error_Function (Display : X_Display;  
                                        Error   : X_Error_Contents);  

    procedure Default_X_Io_Error_Function (Display : X_Display);  


------------------------------------------------------------------------------  
-- Default routines for converter errors  
------------------------------------------------------------------------------  

    procedure Default_X_Rm_Converter_Error (From_Type : X_Rm_Representation;  
                                            To_Type   : X_Rm_Representation);  

    procedure Default_X_Rm_No_Converter_Error (From_Type : X_Rm_Representation;  
                                               To_Type   : X_Rm_Representation);  


------------------------------------------------------------------------------  
-- Invoked to report receipt of an unknown Event type from the server.  
------------------------------------------------------------------------------  

    procedure Default_X_Unknown_Wire_Event  
                 (Display    :     X_Display;  
                  Raw        :     X_Raw_Data_Array;  
                  Send_Event :     Boolean;  
                  Event      : out X_Event;  
                  Queue_It   : out X_Status);  
------------------------------------------------------------------------------  
--  Display       - Specifies the display involved in the event  
--  Raw           - Specifies the data received as the event  
--  Send_Event    - Specifies True if this event was sent by another client  
--  Event         - Receives the translated event (translated from the Raw)  
--  Queue_It      - Receives True if this event is to be placed into the  
--                  Display's queue; returns False to ignore this event  
--  
-- Called in an effort to convert a newly acquired series of raw data into an  
-- Event record.  Called just after the data is received from the server.  
-- This routine never returns.  It raises X_Library_Confusion.  
------------------------------------------------------------------------------  


------------------------------------------------------------------------------  
-- Invoked to report receipt of an unknown Event type from the server.  
------------------------------------------------------------------------------  

    procedure Default_X_Unknown_Native_Event  
                 (Display :     X_Display;  
                  Event   :     X_Event;  
                  Raw     : out X_Raw_Data_Array;  
                  Status  : out X_Status);  
------------------------------------------------------------------------------  
--  Display       - Specifies the display involved in the event  
--  Event         - Specifies the event to be sent on the wire  
--  Raw           - Receives the translated (converted to raw data) event  
--  Status        - Receives Successful if the conversion succeeded; Failed  
--                  for failure  
--  
-- Called in an effort to convert an Event to a series of raw data suitable for  
-- transmission to the server.  
-- This routine never returns.  It raises X_Library_Confusion.  
------------------------------------------------------------------------------  

end Xlbip_Default_Proc_Vars;  

