with Xlbt_Request;  
use Xlbt_Request;  

with Xlbmp_Generic_Converters;  
use Xlbmp_Generic_Converters;  

package Xlbip_Request_Converters is  
------------------------------------------------------------------------------  
-- X Library Internal X_Request/X_Raw_Data Converters  
--  
-- Xlbip_Request_Converters - Conversions to/from system data types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  
--
    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Alloc_Color_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Alloc_Color_Cells_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Alloc_Color_Planes_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Alloc_Named_Color_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Allow_Events_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Bell_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Active_Pointer_Grab_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Gc_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Hosts_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Keyboard_Control_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Keyboard_Mapping_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Pointer_Control_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Property_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Save_Set_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Change_Window_Attributes_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Circulate_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Clear_Area_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Close_Font_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Configure_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Convert_Selection_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Copy_Area_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Copy_Colormap_And_Free_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Copy_Gc_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Copy_Plane_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Create_Colormap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Create_Cursor_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Create_Gc_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Create_Glyph_Cursor_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Create_Pixmap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Create_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Delete_Property_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Destroy_Subwindows_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Destroy_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Fill_Poly_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Force_Screen_Saver_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Free_Colormap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Free_Colors_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Free_Cursor_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Free_Gc_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Free_Pixmap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Atom_Name_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Font_Path_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Geometry_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Image_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Input_Focus_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Keyboard_Control_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Keyboard_Mapping_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Modifier_Mapping_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Motion_Events_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Pointer_Control_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Pointer_Mapping_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Property_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Screen_Saver_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Selection_Owner_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Get_Window_Attributes_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Grab_Button_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Grab_Key_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Grab_Keyboard_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Grab_Pointer_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Grab_Server_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Image_Text16_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Image_Text8_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Install_Colormap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Intern_Atom_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Kill_Client_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_List_Extensions_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_List_Fonts_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_List_Fonts_With_Info_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_List_Hosts_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_List_Installed_Colormaps_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_List_Properties_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Lookup_Color_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Map_Subwindows_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Map_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_No_Operation_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Open_Font_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Arc_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Fill_Arc_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Fill_Rectangle_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Line_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Point_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Rectangle_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Segment_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Text16_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Poly_Text8_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Put_Image_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Best_Size_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Colors_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Extension_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Font_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Keymap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Pointer_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Text_Extents_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Query_Tree_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Recolor_Cursor_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Reparent_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Rotate_Properties_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Send_Event_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Access_Control_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Clip_Rectangles_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Close_Down_Mode_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Dashes_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Font_Path_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Input_Focus_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Modifier_Mapping_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Pointer_Mapping_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Screen_Saver_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Set_Selection_Owner_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Store_Colors_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Color_Item);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Store_Named_Color_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Translate_Coords_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Ungrab_Button_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Ungrab_Key_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Ungrab_Keyboard_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Ungrab_Pointer_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Ungrab_Server_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Uninstall_Colormap_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Unmap_Subwindows_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Unmap_Window_Request);  

    procedure To_Raw is  
       new Convert_Private_To_Raw (X_Warp_Pointer_Request);  

end Xlbip_Request_Converters;  

