with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Hint3;  
use Xlbt_Hint3;  

--/ if Record_Rep_Clauses then  
with Xlbmt_Parameters;  
use Xlbmt_Parameters;  
--/ end if;  

package Xlbit_Hint3 is  
------------------------------------------------------------------------------  
-- X Library Window Manager Hints - Full Interface to Protocol structures  
--  
-- Xlbit_Hint3 - Protocol structures used to give hints to window managers.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Size_Hints_Protocol - The actual protocol record.  This is for use when  
-- performing I/O requests with the server.  These types are not intended for  
-- use by user/application code.  
------------------------------------------------------------------------------  

    type X_Size_Hints_Gravity is (Unmap_Gravity,  
                                  North_West_Gravity,  
                                  North_Gravity,  
                                  North_East_Gravity,  
                                  West_Gravity,  
                                  Center_Gravity,  
                                  East_Gravity,  
                                  South_West_Gravity,  
                                  South_Gravity,  
                                  South_East_Gravity,  
                                  Static_Gravity);  

--/ if Length_Clauses then  
    for X_Size_Hints_Gravity'Size use 32;  
--/ end if;  

    None_X_Size_Hints_Gravity : constant X_Size_Hints_Gravity :=  
       X_Size_Hints_Gravity'Val (0);  

    type X_Size_Hints_Protocol is  
        record  
            Flags       : -- marks which fields in this structure are valid  
               X_Size_Hints_Flags              := None_X_Size_Hints_Flags;  
            X           : S_Long               := 0;  
            Y           : S_Long               := 0;  
            Width       : S_Long               := 0;  
            Height      : S_Long               := 0;  
            Min_Width   : S_Long               := 0;  
            Min_Height  : S_Long               := 0;  
            Max_Width   : S_Long               := 0;  
            Max_Height  : S_Long               := 0;  
            Width_Inc   : S_Long               := 0;  
            Height_Inc  : S_Long               := 0;  
            Min_Aspect  : Aspect_Record;  
            Max_Aspect  : Aspect_Record;  
            Base_Width  : S_Long               := 0;  
            Base_Height : S_Long               := 0;  
            Win_Gravity : X_Size_Hints_Gravity := None_X_Size_Hints_Gravity;  
        end record;  

--/ if Length_Clauses then  
    for X_Size_Hints_Protocol'Size use 18 * 32;  
--/ elsif Pack then  
    pragma Pack (X_Size_Hints_Protocol);  
--/ end if;  

--/ if Record_Rep_Clauses then  
    for X_Size_Hints_Protocol use  
        record  
            Flags       at 0 * X_Word  range X_Word0a .. X_Word0b;  
            X           at 1 * X_Word  range X_Word0a .. X_Word0b;  
            Y           at 2 * X_Word  range X_Word0a .. X_Word0b;  
            Width       at 3 * X_Word  range X_Word0a .. X_Word0b;  
            Height      at 4 * X_Word  range X_Word0a .. X_Word0b;  
            Min_Width   at 5 * X_Word  range X_Word0a .. X_Word0b;  
            Min_Height  at 6 * X_Word  range X_Word0a .. X_Word0b;  
            Max_Width   at 7 * X_Word  range X_Word0a .. X_Word0b;  
            Max_Height  at 8 * X_Word  range X_Word0a .. X_Word0b;  
            Width_Inc   at 9 * X_Word  range X_Word0a .. X_Word0b;  
            Height_Inc  at 10 * X_Word range X_Word0a .. X_Word0b;  
            Min_Aspect  at 11 * X_Word range X_Word0a .. X_Word0a + 63;  
            Max_Aspect  at 13 * X_Word range X_Word0a .. X_Word0a + 63;  
            Base_Width  at 15 * X_Word range X_Word0a .. X_Word0b;  
            Base_Height at 16 * X_Word range X_Word0a .. X_Word0b;  
            Win_Gravity at 17 * X_Word range X_Word0a .. X_Word0b;  
        end record;  
--/ end if;  


--
end Xlbit_Hint3;  

