with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Exceptions;  
use Xlbt_Exceptions;  
with Xlbt_Key;  
use Xlbt_Key;  
with Xlbt_Rm3;  
use Xlbt_Rm3;  
with Xlbt_String;  
use Xlbt_String;  

with Xlbp_Proc_Var;  
use Xlbp_Proc_Var;  
with Xlbp_Rm_Name;  
use Xlbp_Rm_Name;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

with Xlbit_Library3;  
use Xlbit_Library3;  
with Xlbit_Library4;  
use Xlbit_Library4;  

with Xlbip_Base_Converters;  
use Xlbip_Base_Converters;  
with Xlbip_Default_Proc_Vars;  
use Xlbip_Default_Proc_Vars;  

pragma Elaborate (Xlbp_Proc_Var);  
pragma Elaborate (Xlbit_Library3);  

package body Xlbit_Library2 is  
------------------------------------------------------------------------------  
-- X Library Internal State  
--  
-- Xlbit_Library2 - Library State - No packages have any non-constant state  
-- other than this set of packages.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--     function Default_X_Rm_Converter_Error_Type is  
--        new Proc_Var_X_Rm_Converter_Error.Value (Default_X_Rm_Converter_Error);  
--  
--     function Default_X_Rm_No_Converter_Error_Type is  
--        new Proc_Var_X_Rm_Converter_Error.Value  
--               (Default_X_Rm_No_Converter_Error);  
--  

--
    procedure New_X_Library is  
------------------------------------------------------------------------------  
----Called to initialize a new instance of the X_Library structure.  This is  
--  used to contain all of the state common to a group of X_Display's.  
--  
-- This code resides in Xlbit_Library2 instead of in Xlbit_Library3 as a means  
-- of eliminating circular elaboration dependencies.  This code cannot  
-- elaborate until Xlbp_Proc_Var elaborates which depends upon the Spec and  
-- Body of Xlbt_Proc_Var which depends upon the spec of Xlbit_Library3.  
------------------------------------------------------------------------------  
    begin  

----Set the various default values for some of the procedure variables.  

--         X_Lib_Rm_Conversion_Error := Proc_Var_X_Rm_Converter_Error.From_Pv  
--                                         (Default_X_Rm_Converter_Error_Type);  
--         X_Lib_Rm_No_Converter     := Proc_Var_X_Rm_Converter_Error.From_Pv  
--                                         (Default_X_Rm_No_Converter_Error_Type);  
--  
--         X_Lib_Default_X_Rm_Converter_Error    := X_Lib.Rm_Conversion_Error;  
--         X_Lib_Default_X_Rm_No_Converter_Error := X_Lib.Rm_No_Converter;  

----Determine our Endian'ness.  Are we Big Endian or Little Endian?  

        declare  
            Indian_Long  : S_Long := 1;  
            Indian_Array : X_Raw_Data_Array (1 .. S_Long'Size / 8);  
        begin  
            To_Raw (Indian_Array, Indian_Long);  
            if Indian_Array (Indian_Array'First) = 1 then  
                X_Lib_Indian :=  
                   'l';      -- 1 in low addressed byte; we are small endian  
            else  
                X_Lib_Indian :=  
                   'B';      -- 1 in high addressed byte; we are big endian  
                if Indian_Array (Indian_Array'Last) /= 1 then  
                    raise X_Library_Confusion;  
                end if;  
            end if;  
        end;  

----Init our X_Rm_Quark "constants".  

        declare  
            Map : X_Rm_Quark_Map.Map;  
        begin  
            X_Lib.Seize_Quark_Map (Map);  
            X_Rm_Quark_Map.New_Map (Map);  
            X_Lib.Release_Quark_Map (Map);  
        end;  
        X_Lib_X_Rm_R_String := X_Rm_String_To_Representation ("String");  

    end New_X_Library;  

--
begin  

    New_X_Library;  

end Xlbit_Library2;  

