with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Display3;  
use Xlbt_Display3;  
with Xlbt_Key;  
use Xlbt_Key;  
with Xlbt_Rm3;  
use Xlbt_Rm3;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_Proc_Var;  
use Xlbt_Proc_Var;  

with Xlbip_String_Map_Generic;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

package Xlbit_Library4 is  
------------------------------------------------------------------------------  
-- X Library Internal State  
--  
-- Xlbit_Library4 - Constant state; never modified once initialized.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Ks_Info_Map - keysym name to keysym code map  
------------------------------------------------------------------------------  

    package X_Ks_Info_Map is  
       new Xlbip_String_Map_Generic (Character        => X_Character,  
                                     Index            => S_Natural,  
                                     String           => X_String,  
                                     String_Pointer   => X_String_Pointer,  
                                     Range_Type       => X_Key_Sym,  
                                     Hash_Size        => 211,  
                                     Exact_Case_Match => True);  

------------------------------------------------------------------------------  
-- Cache of Write-Once library state.  
------------------------------------------------------------------------------  

----Cache of knowledge about errors.  If it has a value of None then use the  
--  Xlbit_Library3 interface to initialize it.  

    X_Lib_Error_Message_Db : X_Rm_Database := None_X_Rm_Database;  

----Key_Sym string/code map.  Map to/from all known key symbol values and their  
--  associated string names.  If it has a value of None then use the  
--  Xlbit_Library3 interface to initialize it.  

    X_Lib_Ks_Info_Map : X_Ks_Info_Map.Map := X_Ks_Info_Map.None_Map;  

----This fellow is strictly for the use of the RM.  The representation "String".  

    X_Lib_X_Rm_R_String : X_Rm_Representation;  

----Set to 'l' if we are a small endian machine architecture.  
--  Set to 'B' if we are big endian machine architecture.  

    X_Lib_Indian : Character := Ascii.Nul;  

----Various "default" procedure variable values within the library.  
--  Since they are usually implemented with heap memory we want  
--  to have only one allocated value for each.  Never change one  
--  of these values and never deallocate them.  They are set by the elabortion  
--  of various library packages, if those packages are included in the  
--  final program.  

    X_Lib_Default_X_Add_Pixel             : X_Procedure_Variable;  
    X_Lib_Default_X_Create_Image          : X_Procedure_Variable;  
    X_Lib_Default_X_Destroy_Image         : X_Procedure_Variable;  
    X_Lib_Default_X_Get_Pixel             : X_Procedure_Variable;  
    X_Lib_Default_X_Get_Pixel_8           : X_Procedure_Variable;  
    X_Lib_Default_X_Get_Pixel_1           : X_Procedure_Variable;  
    X_Lib_Default_X_Put_Pixel             : X_Procedure_Variable;  
    X_Lib_Default_X_Put_Pixel_8           : X_Procedure_Variable;  
    X_Lib_Default_X_Put_Pixel_1           : X_Procedure_Variable;  
    X_Lib_Default_X_Sub_Image             : X_Procedure_Variable;  
    X_Lib_Default_X_Report_Error          : X_Procedure_Variable;  
    X_Lib_Default_X_Io_Error_Function     : X_Procedure_Variable;  
    X_Lib_Default_X_Error_Function        : X_Procedure_Variable;  
    X_Lib_Default_X_Event_To_Wire         : X_Procedure_Variable;  
    X_Lib_Default_X_Wire_To_Event         : X_Procedure_Variable;  
    X_Lib_Default_X_Unknown_Wire_Event    : X_Procedure_Variable;  
    X_Lib_Default_X_Unknown_Native_Event  : X_Procedure_Variable;  
    X_Lib_Default_X_Sync_Function         : X_Procedure_Variable;  
    X_Lib_Default_X_Rm_Converter_Error    : X_Procedure_Variable;  
    X_Lib_Default_X_Rm_No_Converter_Error : X_Procedure_Variable;  
    X_Lib_Default_Restack_Error_Handler   : X_Procedure_Variable;  
    X_Lib_Default_X_Alloc_Id              : X_Procedure_Variable;  

--
end Xlbit_Library4;  

