with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_Display3;  
use Xlbt_Display3;  
with Xlbt_Error3;  
use Xlbt_Error3;  
with Xlbt_Extension3;  
use Xlbt_Extension3;  
with Xlbt_Font3;  
use Xlbt_Font3;  
with Xlbt_Gc3;  
use Xlbt_Gc3;  
with Xlbt_Proc_Var;  
use Xlbt_Proc_Var;  
with Xlbt_Image3;  
use Xlbt_Image3;  
with Xlbt_Rm;  
use Xlbt_Rm;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_Univ_Ptr;  
use Xlbt_Univ_Ptr;  
with Xlbt_Visual3;  
use Xlbt_Visual3;  

with Xlbmt_Error_Log;  
use Xlbmt_Error_Log;  
with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  

pragma Elaborate (Xlbt_Proc_Var);  

package Xlbp_Proc_Var is  
------------------------------------------------------------------------------  
-- X Library Types  
--  
-- Xlbt_Proc_Var - Procedure-variable types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
----X_Alloc_Id - Allocate a new X resource ID  

    package Proc_Var_X_Alloc_Id is  
       new Func_In (X_Display, X_Id);  

----X_Add_Pixel - Add pixel value to every pixel in an image  

    package Proc_Var_X_Add_Pixel is  
       new Proc_In_In (X_Image, X_Pixel);  

----X_Close_Display_Extension - Closing display extension hook  

    package Proc_Var_X_Close_Display_Extension is  
       new Proc_In_In (X_Display, X_Ext_Codes);  

----X_Create_Image - Create an image from data  

    package Proc_Var_X_Create_Image is  
       new Func_In10 (X_Display, X_Visual, U_Char, X_Image_Format, U_Short,  
                      U_Char_Array, U_Short, U_Short, U_Char, U_Short, X_Image);  

----X_Destroy_Image - Destroy/Deallocate an image  

    package Proc_Var_X_Destroy_Image is  
       new Proc_Inout (X_Image);  

----X_Display_Font_Extension - Font extension hook  

    package Proc_Var_X_Display_Font_Extension is  
       new Proc_In_In_In (X_Display, X_Font_Struct, X_Ext_Codes);  

----X_Display_Gc_Extension - GC extension hook  

    package Proc_Var_X_Display_Gc_Extension is  
       new Proc_In_In_In (X_Display, X_Gc, X_Ext_Codes);  

----X_Error_Extension - Error reporting extension hook  

    package Proc_Var_X_Error_Extension is  
       new Proc_In_In_In_Out_Out (X_Display, X_Error_Contents,  
                                  X_Ext_Codes, X_Status, Boolean);  

----X_Error_Function - X Protocol error reporting  

    package Proc_Var_X_Error_Function is  
       new Proc_In_In (X_Display, X_Error_Contents);  

----X_Error_String_Extension - Error explanation extension hook  

    package Proc_Var_X_Error_String_Extension is  
       new Func_In_In_In_X_String (X_Display, X_Error_Code, X_Ext_Codes);  

----X_Event_Wire - Called to convert X_Event format event to wire-format event.  

    package Proc_Var_X_Event_Wire is  
       new Proc_In_In_Out_Out (X_Display, X_Event,  
                               X_Raw_Data_Array, X_Status);  

----X_Flush_Extension_Graphics - Called to flush an extension's Last_Req for  
--  a Dpy.  

    package Proc_Var_X_Flush_Extension_Graphics is  
       new Proc_In (X_Display);  

----X_Free_Extension_Data - Free up storage associated with an extension  

    package Proc_Var_X_Free_Extension_Data is  
       new Proc_Inout (X_Universal_Pointer);  

----X_Get_Pixel - Get pixel value from X/Y location in image.  

    package Proc_Var_X_Get_Pixel is  
       new Func_In_In_In (X_Image, S_Short, S_Short, X_Pixel);  

----X_Io_Error_Function - I/O error reporting  

    package Proc_Var_X_Io_Error_Function is  
       new Proc_In (X_Display);  

----X_Put_Pixel  

    package Proc_Var_X_Put_Pixel is  
       new Proc_In_In_In_In (X_Image, S_Short, S_Short, X_Pixel);  

----X_Report_Error - the lowest level error reporting function.  

    package Proc_Var_X_Report_Error is  
       new Proc_In10 (X_String, X_String, X_String, X_String,  
                      X_String, X_String, X_String, X_String,  
                      X_String, X_Report_Message_Kind);  

-- ----X_Rm_Converter - X_Rm's type conversion routine  
--  
--     package Proc_Var_X_Rm_Converter is  
--        new Proc_In_In_In (X_Screen, X_Rm_Value, X_Rm_Value);  
--  
-- ----X_Rm_Converter_Error - Report X_Rm_Converter conversion errors  
--  
--     package Proc_Var_X_Rm_Converter_Error is  
--        new Proc_In_In (X_Rm_Representation, X_Rm_Representation);  

----X_Sub_Image - Carve a sub-image out of an image  

    package Proc_Var_X_Sub_Image is  
       new Func_In5 (X_Image, S_Short, S_Short, U_Short, U_Short, X_Image);  

----X_Synchandler - cause every operation on a display to synchronize  

    package Proc_Var_X_Synchandler is  
       new Proc_In (X_Display);  

----X_Univ_Free - Called to free up a Universal Pointer  

    package Proc_Var_X_Univ_Free is  
       new Proc_Inout (X_Universal_Pointer);  

----X_Univ_To_String - Called to convert a Universal Pointer into a string value.  

    package Proc_Var_X_Univ_To_String is  
       new Func_In_X_String (X_Universal_Pointer);  

----X_Wire_Event - called to convert wire-format event to X_Event format event.  

    package Proc_Var_X_Wire_Event is  
       new Proc_In_In_In_Out_Out (X_Display, X_Raw_Data_Array, Boolean,  
                                  X_Event, X_Status);  

end Xlbp_Proc_Var;  

