with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Hint;  
use Xlbt_Hint;  
with Xlbit_Hint2;  
use Xlbit_Hint2;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_String16;  
use Xlbt_String16;  

with Xlbp_U_Char_Generics;  
use Xlbp_U_Char_Generics;  

package Xlbp_U_Char_Converters is  
------------------------------------------------------------------------------  
-- X Library Basic Converters  
--  
-- Xlbp_U_Char_Converters - Conversion to/from U_Char_Array.  
------------------------------------------------------------------------------  
-- Copyright 1990 - 1991 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Atom  
------------------------------------------------------------------------------  

    procedure From_Uca is  
       new Convert_Uca_To_Array (X_Atom,  
                                 S_Natural,  
                                 X_Atom_Array);  

    procedure To_Uca is new Convert_Array_To_Uca (X_Atom,  
                                                  S_Natural,  
                                                  X_Atom_Array);  

------------------------------------------------------------------------------  
-- X_Icon_Size  
------------------------------------------------------------------------------  

    procedure From_Uca is new Convert_Uca_To_Array (X_Icon_Size,  
                                                    S_Natural,  
                                                    X_Icon_Size_Array);  

    procedure To_Uca is new Convert_Array_To_Uca (X_Icon_Size,  
                                                  S_Natural,  
                                                  X_Icon_Size_Array);  

------------------------------------------------------------------------------  
-- X_Size_Hints_Protocol  
------------------------------------------------------------------------------  

    procedure To_Uca is new Convert_Private_To_Uca (X_Size_Hints_Protocol);  

    procedure From_Uca is new Convert_Uca_To_Private (X_Size_Hints_Protocol);  

------------------------------------------------------------------------------  
-- X_Standard_Colormap  
------------------------------------------------------------------------------  

    procedure From_Uca is  
       new Convert_Uca_To_Private (X_Standard_Colormap);  

    procedure To_Uca is  
       new Convert_Array_To_Uca (X_Standard_Colormap,  
                                 S_Natural,  
                                 X_Standard_Colormap_Array);  

------------------------------------------------------------------------------  
-- X_Window  
------------------------------------------------------------------------------  

    procedure To_Uca is new Convert_Private_To_Uca (X_Window);  

    procedure From_Uca is new Convert_Uca_To_Private (X_Window);  

    procedure To_Uca is new Convert_Array_To_Uca (X_Window,  
                                                  S_Natural,  
                                                  X_Window_Array);  

    procedure From_Uca is new Convert_Uca_To_Array (X_Window,  
                                                    S_Natural,  
                                                    X_Window_Array);  

------------------------------------------------------------------------------  
-- X_Wm_Hints  
------------------------------------------------------------------------------  

    procedure To_Uca is new Convert_Private_To_Uca (X_Wm_Hints);  

    procedure From_Uca is new Convert_Uca_To_Private (X_Wm_Hints);  

------------------------------------------------------------------------------  
-- S_Char  
------------------------------------------------------------------------------  

    procedure To_Uca is  
       new Convert_Discrete_To_Uca (S_Char);  

    procedure From_Uca is  
       new Convert_Uca_To_Discrete (S_Char);  
------------------------------------------------------------------------------  
-- S_Short  
------------------------------------------------------------------------------  

    procedure To_Uca is  
       new Convert_Discrete_To_Uca (S_Short);  

    procedure From_Uca is  
       new Convert_Uca_To_Discrete (S_Short);  

------------------------------------------------------------------------------  
-- S_Long  
------------------------------------------------------------------------------  

    procedure To_Uca is  
       new Convert_Discrete_To_Uca (S_Long);  

    procedure From_Uca is  
       new Convert_Uca_To_Discrete (S_Long);  

------------------------------------------------------------------------------  
-- U_Short  
------------------------------------------------------------------------------  

    procedure To_Uca is  
       new Convert_Discrete_To_Uca (U_Short);  

    procedure From_Uca is  
       new Convert_Uca_To_Discrete (U_Short);  

--
------------------------------------------------------------------------------  
-- String  
------------------------------------------------------------------------------  

    type U_Character_Array is array (U_Char) of Character;  

    procedure To_Uca (Uca : out U_Char_Array;  
                      Str :     String);  
    ----Take a String and return the corresponding U_Char_Array.  

    procedure From_Uca (Str : out String;  
                        Uca :     U_Char_Array);  
    ----Take a UCA and return the corresponding String.  Chops each  
    --  raw datum down to 7 bits as the conversion is made.  

    procedure From_Uca (Str   : out String;  
                        Uca   :     U_Char_Array;  
                        Trans :     U_Character_Array);  
    ----Take a U_Char_Array and translate each character in it into a 7-bit  
    --  character and return the translated string.  

------------------------------------------------------------------------------  
-- X_String  
------------------------------------------------------------------------------  

    procedure From_Uca is  
       new Convert_Uca_To_Array (X_Character,  
                                 S_Natural,  
                                 X_String);  

    procedure To_Uca is  
       new Convert_Array_To_Uca (X_Character,  
                                 S_Natural,  
                                 X_String);  
------------------------------------------------------------------------------  
-- X_String16  
------------------------------------------------------------------------------  

    procedure From_Uca is  
       new Convert_Uca_To_Array (X_Character16,  
                                 S_Natural,  
                                 X_String16);  

    procedure To_Uca is  
       new Convert_Array_To_Uca (X_Character16,  
                                 S_Natural,  
                                 X_String16);  

end Xlbp_U_Char_Converters;  

