with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  

package Xlbp_Pixmap is  
------------------------------------------------------------------------------  
-- X Library Pixmaps  
--  
-- Xlbp_Pixmap - Create and destroy Pixmaps  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    function X_Create_Pixmap (Display  : X_Display;  
                              Drawable : X_Drawable;  
                              Width    : U_Short_Positive;  
                              Height   : U_Short_Positive;  
                              Depth    : U_Char) return X_Pixmap;  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Drawable - Specifies the drawable (Window, Pixmap) to use.  
--  Width    - Specifies the width, in pixels, of the new drawable.  
--  Height   - Specifies the height, in pixels, of the new drawable.  
--  Depth    - Specifies the depth of the new drawable.  Must be a depth  
--             supported by the root of the drawable.  
--  
-- Creates a pixmap of the specified width, height, and depth.  Returns  
-- None_X_Pixmap if there was insufficient space for the new pixmap.  
------------------------------------------------------------------------------  

    procedure X_Free_Pixmap (Display : X_Display;  
                             Pixmap  : X_Pixmap);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Pixmap  - Specifies the pixmap to free.  
--  
-- Removes the association between the pixmap ID and the pixmap and then  
-- the X server frees the pixmap storage when no other resources reference  
--  it.  
------------------------------------------------------------------------------  

end Xlbp_Pixmap;  

