with Xlbt_Basic;  
use Xlbt_Basic;  

package Xlbp_Selection is  
------------------------------------------------------------------------------  
-- X Library Selections  
--  
-- Xlbp_Selection - Control of user selections  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure X_Convert_Selection (Display   : X_Display;  
                                   Selection : X_Atom;  
                                   Target    : X_Atom;  
                                   Property  : X_Atom;  
                                   Requestor : X_Window;  
                                   Time      : X_Time);  
------------------------------------------------------------------------------  
--  Display   - Specifies the display to use.  
--  Selection - Specifies the atom identifier for the selection.  
--  Target    - Specifies the target atom identifier.  
--  Property  - Specifies the property atom.  None_X_Atom may be used.  
--  Requestor - Specifies the requestor window.  
--  Time      - Specifies the time.  May be a timestamp, expressed in  
--              milliseconds, or may be Current_Time.  
--  
-- Requests that the specified selection be converted to the specified target  
-- type.  
------------------------------------------------------------------------------  

    function X_Get_Selection_Owner (Display   : X_Display;  
                                    Selection : X_Atom) return X_Window;  
------------------------------------------------------------------------------  
--  Display   - Specifies the display to use.  
--  Selection - Specifies the atom identifier for the selection.  
--  
-- Returns the window ID associated with the window that currently owns the  
-- specified selection.  Returns None_X_Window if there is no associated owner.  
------------------------------------------------------------------------------  

    procedure X_Set_Selection_Owner (Display   : X_Display;  
                                     Selection : X_Atom;  
                                     Owner     : X_Window;  
                                     Time      : X_Time);  
------------------------------------------------------------------------------  
--  Display   - Specifies the display to use.  
--  Selection - Specifies the atom identifier for the selection.  
--  Owner     - Specifies the new owner of the selection.  None_X_Window may be  
--              used.  
--  Time      - Specifies the time.  May be a timestamp, expressed in  
--              milliseconds, or may be Current_Time.  
--  
-- Changes the owner and last change time for the specified selection.  The  
-- function has no effect if the value passed for Time is earlier than the  
-- current last-change-time of the specified selection or later than the  
-- current X server time.  Current_Time always corresponds to the current  
-- X server time.  If None_X_Window is used as the new Owner then the current  
-- owner becomes None_X_Window (no owner).  
------------------------------------------------------------------------------  

end Xlbp_Selection;  

