with Xlbt_Basic;  
use Xlbt_Basic;  

with Xlbp_Proc_Var;  
use Xlbp_Proc_Var;  

package Xlbp_Sync is  
------------------------------------------------------------------------------  
-- X Library Synchronize  
--  
-- Xlbp_Sync - Error detection server synchronization.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure X_Sync (Display : X_Display;  
                      Discard : Boolean);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Discard - Specifies True to cause all events up to the sync point to be  
--            discarded.  
--  
-- Like X_Flush but in addition it waits until all events and errors resulting  
-- from the flushed requests (or requests prior to the flushed events) have  
-- returned from the server.  Discard tells us whether to discard all events  
-- or not.  Error events are always passed to the Xlib error reporting routine.  
------------------------------------------------------------------------------  

    function X_Synchronize (Display : X_Display;  
                            Onoff   : Boolean) return Proc_Var_X_Synchandler.Pv;  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Onoff   - True to turn on synchronous behavior; False to turn it off.  
--  
-- Makes Xlib protocol message calls "synchronous".  No Xlib routine that  
-- creates a protocol message to the server will return until the function  
-- requested has been performed.  Turns the usage of the  
-- X_Set_After_Function on and off.  Returns the current sync function.  
------------------------------------------------------------------------------  

    function X_Set_After_Function (Display : X_Display;  
                                   Funct   : Proc_Var_X_Synchandler.Pv)  
                                  return Proc_Var_X_Synchandler.Pv;  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Funct   - Specifies the function to use.  
--  
-- Set the function that will be called after each and every server request  
-- is queued.  The previous "after" function is returned.  
------------------------------------------------------------------------------  

end Xlbp_Sync;  

