with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Font;  
use Xlbt_Font;  
with Xlbt_String16;  
use Xlbt_String16;  
with Xlbt_Text;  
use Xlbt_Text;  

package Xlbp_Text16 is  
------------------------------------------------------------------------------  
-- X Library Text - 16-bit characters  
--  
-- Xlbp_Text16 - Handle drawing of 16-bit characters  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    procedure X_Draw_String16 (Display  : X_Display;  
                               Drawable : X_Drawable;  
                               Gc       : X_Gc;  
                               X        : S_Short;  
                               Y        : S_Short;  
                               Text     : X_String16);  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Drawable - Specifies the drawable to draw upon (Window, Pixmap).  
--  Gc       - Specifies the graphics context to use.  
--  X        - Specifies the X coordinate where drawing begins.  
--  Y        - Specifies the Y coordinate where drawing begins.  
--  Text     - Specifies the characters to be drawn.  
--  
-- Draws a series of character items on the specified drawable.  
------------------------------------------------------------------------------  

    procedure X_Draw_Image_String16 (Display  : X_Display;  
                                     Drawable : X_Drawable;  
                                     Gc       : X_Gc;  
                                     X        : S_Short;  
                                     Y        : S_Short;  
                                     Text     : X_String16);  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Drawable - Specifies the drawable to draw upon (Window, Pixmap).  
--  Gc       - Specifies the graphics context to use.  
--  X        - Specifies the X coordinate where drawing begins.  
--  Y        - Specifies the Y coordinate where drawing begins.  
--  Text     - Specifies the characters to be drawn.  
--  
-- Draws a series of character items on the specified drawable.  Draws both  
-- the foreground and background pixels in order to eliminate flicker on  
-- some displays.  
------------------------------------------------------------------------------  

    procedure X_Draw_Text16 (Display  : X_Display;  
                             Drawable : X_Drawable;  
                             Gc       : X_Gc;  
                             X        : S_Short;  
                             Y        : S_Short;  
                             Items    : X_Text_Item16_Array);  
------------------------------------------------------------------------------  
--  Display  - Specifies the display to use.  
--  Drawable - Specifies the drawable to draw upon (Window, Pixmap).  
--  Gc       - Specifies the graphics context to use.  
--  X        - Specifies the X coordinate where drawing begins.  
--  Y        - Specifies the Y coordinate where drawing begins.  
--  Items    - Specifies the text items to be drawn.  
--  
-- Draws a series of character items on the specified drawable.  
------------------------------------------------------------------------------  

    procedure X_Query_Text_Extents16 (Display      :     X_Display;  
                                      Font         :     X_Font;  
                                      Text         :     X_String16;  
                                      Direction    : out X_Font_Direction;  
                                      Font_Ascent  : out S_Short;  
                                      Font_Descent : out S_Short;  
                                      Overall      : out X_Char_Struct);  
------------------------------------------------------------------------------  
--  Display       - Specifies the display to use.  
--  Font          - Specifies the font ID to use.  
--  Text          - Specifies the string to use.  
--  Direction     - Receives the drawing direction hint.  
--  Font_Ascent   - Receives the font ascent.  
--  Font_Descent  - Receives the font descent.  
--  Overall       - Receives the overall size of the string when drawn.  
--  
-- Returns the bounding box of the specified string from the server.  
------------------------------------------------------------------------------  

    procedure X_Text_Extents16 (Font         :     X_Font_Struct;  
                                Text         :     X_String16;  
                                Direction    : out X_Font_Direction;  
                                Font_Ascent  : out S_Short;  
                                Font_Descent : out S_Short;  
                                Overall      : out X_Char_Struct);  
------------------------------------------------------------------------------  
--  Font         - Specifies the font structure to use.  
--  Text         - Specifies the string to use.  
--  Direction    - Receives the drawing direction hint.  
--  Font_Ascent  - Receives the font ascent.  
--  Font_Descent - Receives the font descent.  
--  Overall      - Receives the overall size of the string when drawn.  
--  
-- Returns the bounding box of the specified string.  
------------------------------------------------------------------------------  

    function X_Text_Width16 (Font : X_Font_Struct;  
                             Text : X_String16) return S_Long;  
------------------------------------------------------------------------------  
--  Font - Specifies the font structure to use.  
--  Text - Specifies the string to use.  
--  
-- Returns the display width of the string, in pixels.  
------------------------------------------------------------------------------  

end Xlbp_Text16;  

