with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Visual;  
use Xlbt_Visual;  

package Xlbp_Visual is  
------------------------------------------------------------------------------  
-- X Library Visual Information  
--  
-- Xlbp_Visual - Used to obtain information upon the various visual  
-- display types possible with a particular server  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    function X_Get_Visual_Info (Display     : X_Display;  
                                Values_Mask : X_Visual_Info_Flags;  
                                Values      : X_Visual_Info)  
                               return X_Visual_Info_List;  
------------------------------------------------------------------------------  
--  Display     - Specifies the display to use.  
--  Values_Mask - Specifies the visual mask value.  
--  Values      - Specifies the visual attributes that are to be used  
--                in matching the visual structures.  
--  
-- Obtains a list of visual structures that match a specified template.  
-- Returns None_X_Visual_Info_List if no visual structures matched the template.  
--  
-- Free the list after use with the Free_X_Visual_Info_List routine.  
------------------------------------------------------------------------------  

    procedure X_Match_Visual_Info (Display :     X_Display;  
                                   Screen  :     X_Screen_Number;  
                                   Depth   :     U_Char;  
                                   Class   :     X_Display_Class;  
                                   Values  : out X_Visual_Info;  
                                   Status  : out X_Status);  
------------------------------------------------------------------------------  
--  Display - Specifies the display to use.  
--  Screen  - Specifies the screen to use.  
--  Depth   - Specifies the depth of the screen.  
--  Class   - Specifies the class of the screen.  
--  Values  - Receives the match visual information.  
--  Status  - Receives Successful or Failed.  
--  
-- Returns the visual information for a visual that matches the specified  
-- depth and class for a screen.  Because multiple visuals that match the  
-- specified depth and class can exist, the exact visual chosen is undefined.  
------------------------------------------------------------------------------  

end Xlbp_Visual;  

