with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  

package Xlbt_Atom_Defs is  
------------------------------------------------------------------------------  
-- X Library Predefined Atoms  
--  
-- Xlbt_Atom_Defs - Predefined atoms  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- Predefined Atoms  
------------------------------------------------------------------------------  

    Xa_Primary             : constant X_Atom := (Number => 1);  
    Xa_Secondary           : constant X_Atom := (Number => 2);  
    Xa_Arc                 : constant X_Atom := (Number => 3);  
    Xa_Atom                : constant X_Atom := (Number => 4);  
    Xa_Bitmap              : constant X_Atom := (Number => 5);  
    Xa_Cardinal            : constant X_Atom := (Number => 6);  
    Xa_Colormap            : constant X_Atom := (Number => 7);  
    Xa_Cursor              : constant X_Atom := (Number => 8);  
    Xa_Cut_Buffer0         : constant X_Atom := (Number => 9);  
    Xa_Cut_Buffer1         : constant X_Atom := (Number => 10);  
    Xa_Cut_Buffer2         : constant X_Atom := (Number => 11);  
    Xa_Cut_Buffer3         : constant X_Atom := (Number => 12);  
    Xa_Cut_Buffer4         : constant X_Atom := (Number => 13);  
    Xa_Cut_Buffer5         : constant X_Atom := (Number => 14);  
    Xa_Cut_Buffer6         : constant X_Atom := (Number => 15);  
    Xa_Cut_Buffer7         : constant X_Atom := (Number => 16);  
    Xa_Drawable            : constant X_Atom := (Number => 17);  
    Xa_Font                : constant X_Atom := (Number => 18);  
    Xa_Integer             : constant X_Atom := (Number => 19);  
    Xa_Pixmap              : constant X_Atom := (Number => 20);  
    Xa_Point               : constant X_Atom := (Number => 21);  
    Xa_Rectangle           : constant X_Atom := (Number => 22);  
    Xa_Resource_Manager    : constant X_Atom := (Number => 23);  
    Xa_Rgb_Color_Map       : constant X_Atom := (Number => 24);  
    Xa_Rgb_Best_Map        : constant X_Atom := (Number => 25);  
    Xa_Rgb_Blue_Map        : constant X_Atom := (Number => 26);  
    Xa_Rgb_Default_Map     : constant X_Atom := (Number => 27);  
    Xa_Rgb_Gray_Map        : constant X_Atom := (Number => 28);  
    Xa_Rgb_Green_Map       : constant X_Atom := (Number => 29);  
    Xa_Rgb_Red_Map         : constant X_Atom := (Number => 30);  
    Xa_String              : constant X_Atom := (Number => 31);  
    Xa_Visualid            : constant X_Atom := (Number => 32);  
    Xa_Window              : constant X_Atom := (Number => 33);  
    Xa_Wm_Command          : constant X_Atom := (Number => 34);  
    Xa_Wm_Hints            : constant X_Atom := (Number => 35);  
    Xa_Wm_Client_Machine   : constant X_Atom := (Number => 36);  
    Xa_Wm_Icon_Name        : constant X_Atom := (Number => 37);  
    Xa_Wm_Icon_Size        : constant X_Atom := (Number => 38);  
    Xa_Wm_Name             : constant X_Atom := (Number => 39);  
    Xa_Wm_Normal_Hints     : constant X_Atom := (Number => 40);  
    Xa_Wm_Size_Hints       : constant X_Atom := (Number => 41);  
    Xa_Wm_Zoom_Hints       : constant X_Atom := (Number => 42);  
    Xa_Min_Space           : constant X_Atom := (Number => 43);  
    Xa_Norm_Space          : constant X_Atom := (Number => 44);  
    Xa_Max_Space           : constant X_Atom := (Number => 45);  
    Xa_End_Space           : constant X_Atom := (Number => 46);  
    Xa_Superscript_X       : constant X_Atom := (Number => 47);  
    Xa_Superscript_Y       : constant X_Atom := (Number => 48);  
    Xa_Subscript_X         : constant X_Atom := (Number => 49);  
    Xa_Subscript_Y         : constant X_Atom := (Number => 50);  
    Xa_Underline_Position  : constant X_Atom := (Number => 51);  
    Xa_Underline_Thickness : constant X_Atom := (Number => 52);  
    Xa_Strikeout_Ascent    : constant X_Atom := (Number => 53);  
    Xa_Strikeout_Descent   : constant X_Atom := (Number => 54);  
    Xa_Italic_Angle        : constant X_Atom := (Number => 55);  
    Xa_X_Height            : constant X_Atom := (Number => 56);  
    Xa_Quad_Width          : constant X_Atom := (Number => 57);  
    Xa_Weight              : constant X_Atom := (Number => 58);  
    Xa_Point_Size          : constant X_Atom := (Number => 59);  
    Xa_Resolution          : constant X_Atom := (Number => 60);  
    Xa_Copyright           : constant X_Atom := (Number => 61);  
    Xa_Notice              : constant X_Atom := (Number => 62);  
    Xa_Font_Name           : constant X_Atom := (Number => 63);  
    Xa_Family_Name         : constant X_Atom := (Number => 64);  
    Xa_Full_Name           : constant X_Atom := (Number => 65);  
    Xa_Cap_Height          : constant X_Atom := (Number => 66);  
    Xa_Wm_Class            : constant X_Atom := (Number => 67);  
    Xa_Wm_Transient_For    : constant X_Atom := (Number => 68);  

    Xa_Last_Predefined : constant X_Atom := (Number => 68);  

end Xlbt_Atom_Defs;  

