with Xlbt_Basic3;  
with Xlbt_Display3;  

package Xlbt_Basic2 is  
------------------------------------------------------------------------------  
-- X Library Basic Types - Extended User Interface  
--  
-- Xlbt_Basic2 - Types are declared here because they are "low level" types.  
-- They are types which are used to create many other composite types.  
-- They are in some sense "primitive" types.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package B3 renames Xlbt_Basic3;  
    package D3 renames Xlbt_Display3;  

------------------------------------------------------------------------------  
-- X_Drawable  
------------------------------------------------------------------------------  

    subtype X_Drawable_Array is B3.X_Drawable_Array;  
    subtype X_Drawable_List  is B3.X_Drawable_List;  

    None_X_Drawable_List : X_Drawable_List renames B3.None_X_Drawable_List;  

    procedure Free_X_Drawable_List (List : in out X_Drawable_List)  
        renames B3.Free_X_Drawable_List;  

    function "=" (A, B : X_Drawable_List) return Boolean renames B3."=";  

------------------------------------------------------------------------------  
-- X_Event_Mask  
------------------------------------------------------------------------------  

    subtype X_Event_Mask_Array is B3.X_Event_Mask_Array;  

    subtype X_Event_Mask_Short is B3.X_Event_Mask_Short;  

    function "&" (A, B : X_Event_Mask_Array) return X_Event_Mask_Array  
        renames B3."&";  
    function "=" (A, B : X_Event_Mask_Short) return Boolean renames B3."=";  


------------------------------------------------------------------------------  
-- X_Screen  
------------------------------------------------------------------------------  

    subtype X_Screen_List is D3.X_Screen_List;  

    None_X_Screen_List : X_Screen_List renames D3.None_X_Screen_List;  

    function "=" (A, B : X_Screen_List) return Boolean renames D3."=";  


    function X_Event_Mask_Short_To_Long  
                (A : X_Event_Mask_Short) return B3.X_Event_Mask  
        renames B3.X_Event_Mask_Short_To_Long;  
-----------------------------------------------------------------------------  
--  A   - Specifies a short event mask  
--  
-- Called to convert a short event mask into a long event mask.  
------------------------------------------------------------------------------  

end Xlbt_Basic2;  

