with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic;  
use Xlbt_Basic;  
with Xlbt_Rm;  
use Xlbt_Rm;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_Univ_Ptr;  
use Xlbt_Univ_Ptr;  

package body Xlbt_Context_Manager3 is  
------------------------------------------------------------------------------  
-- X Library Context Manager - Full User Interface  
--  
-- Xlbt_Context_Manager3 - Types dealing with Context Management  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--/ if OLD_CONTEXT_MANAGER then  
 
    procedure Heap_Free_X_Context_Hash_List is  
       new Unchecked_Deallocation (X_Context_Hash_Table,  
                                   X_Context_Hash_List);  
--
  
    procedure Free_X_Context_Hash_List (List : in out X_Context_Hash_List) is  
        Ct_Entry : X_Context_Table_Entry;  
        Temp     : X_Context_Table_Entry;  
    begin  
        if List = None_X_Context_Hash_List then  
            return;  
        end if;  
        for I in List'Range loop  
            Ct_Entry := List (I);  
            while Ct_Entry /= null loop  
                Temp     := Ct_Entry;  
                Ct_Entry := Ct_Entry.Next;  
                Free_X_Context_Table_Entry (Temp);  
            end loop;  
        end loop;  
        Heap_Free_X_Context_Hash_List (List);  
    end Free_X_Context_Hash_List;  
 
--/ end if;  
--
end Xlbt_Context_Manager3;  

