with Xlbt_Display3;  

package Xlbt_Display2 is  
------------------------------------------------------------------------------  
-- X Library Display - Extended User Interface  
--  
-- Xlbt_Display2 - Types that need not be imported directly into most programs.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package D3 renames Xlbt_Display3;  

------------------------------------------------------------------------------  
-- X_Depth; contains information for each possible display depth.  
------------------------------------------------------------------------------  

    subtype X_Depth_Rec   is D3.X_Depth_Rec;  
    subtype X_Depth       is D3.X_Depth;  
    subtype X_Depth_Array is D3.X_Depth_Array;  
    subtype X_Depth_List  is D3.X_Depth_List;  

    None_X_Depth      : X_Depth      renames D3.None_X_Depth;  
    None_X_Depth_List : X_Depth_List renames D3.None_X_Depth_List;  

    function "=" (A, B : X_Depth_List) return Boolean renames D3."=";  
    function "=" (A, B : X_Depth)      return Boolean renames D3."=";  

    procedure Free_X_Depth      (Depth : in out X_Depth)  
        renames D3.Free_X_Depth;  
    procedure Free_X_Depth_List (List : in out X_Depth_List)  
        renames D3.Free_X_Depth_List;  

------------------------------------------------------------------------------  
-- X_Display  
------------------------------------------------------------------------------  

    subtype X_Display_Array is D3.X_Display_Array;  
    subtype X_Display_List  is D3.X_Display_List;  

    None_X_Display_List : X_Display_List renames D3.None_X_Display_List;  

    procedure Free_X_Display_List (List : in out X_Display_List)  
        renames D3.Free_X_Display_List;  

    function "=" (A, B : X_Display_List) return Boolean renames D3."=";  

------------------------------------------------------------------------------  
-- X_Display_Flags - Internal flags indicating important state changes  
------------------------------------------------------------------------------  

    subtype X_Display_Flags_Index is D3.X_Display_Flags_Index;  

    Xlib_Display_Io_Error : constant X_Display_Flags_Index :=  
       D3.Xlib_Display_Io_Error;  
    ----An I/O error occurred on the network  

    Xlib_Display_Closing : constant X_Display_Flags_Index :=  
       D3.Xlib_Display_Closing;  
    ----The display connection is closing down  

------------------------------------------------------------------------------  
-- X_Display  
------------------------------------------------------------------------------  

    subtype X_Display_Rec is D3.X_Display_Rec;  

------------------------------------------------------------------------------  
-- X_Last_Request - Last graphic request made  
------------------------------------------------------------------------------  

    subtype X_Last_Request is D3.X_Last_Request;  

------------------------------------------------------------------------------  
-- X_Queued_Event data type for use in input queueing.  
------------------------------------------------------------------------------  

    subtype X_Queued_Event_Rec is D3.X_Queued_Event_Rec;  
    subtype X_Queued_Event     is D3.X_Queued_Event;  

    None_X_Queued_Event : X_Queued_Event renames D3.None_X_Queued_Event;  

    function "=" (A, B : X_Queued_Event) return Boolean renames D3."=";  

    procedure Free_X_Queued_Event (Event : in out X_Queued_Event)  
        renames D3.Free_X_Queued_Event;  

------------------------------------------------------------------------------  
-- X_Screen - Information about the screen.  
------------------------------------------------------------------------------  

    subtype X_Screen_Rec is D3.X_Screen_Rec;  

    subtype X_Screen_Array is D3.X_Screen_Array;  
    subtype X_Screen_List  is D3.X_Screen_List;  

    None_X_Screen_List : X_Screen_List renames D3.None_X_Screen_List;  

    function "=" (A, B : X_Screen_List) return Boolean renames D3."=";  

    procedure Free_X_Screen      (Screen : in out D3.X_Screen)  
        renames D3.Free_X_Screen;  
    procedure Free_X_Screen_List (List : in out X_Screen_List)  
        renames D3.Free_X_Screen_List;  

------------------------------------------------------------------------------  
-- X_Screen_Format - describes Z_Format data the screen will understand.  
------------------------------------------------------------------------------  

    subtype X_Screen_Format_Rec   is D3.X_Screen_Format_Rec;  
    subtype X_Screen_Format       is D3.X_Screen_Format;  
    subtype X_Screen_Format_Array is D3.X_Screen_Format_Array;  
    subtype X_Screen_Format_List  is D3.X_Screen_Format_List;  

    None_X_Screen_Format      : X_Screen_Format renames D3.None_X_Screen_Format;  
    None_X_Screen_Format_List : X_Screen_Format_List  
        renames D3.None_X_Screen_Format_List;  

    function "=" (A, B : X_Screen_Format)      return Boolean renames D3."=";  
    function "=" (A, B : X_Screen_Format_List) return Boolean renames D3."=";  

    procedure Free_X_Screen_Format      (Format : in out X_Screen_Format)  
        renames D3.Free_X_Screen_Format;  
    procedure Free_X_Screen_Format_List (List : in out X_Screen_Format_List)  
        renames D3.Free_X_Screen_Format_List;  

------------------------------------------------------------------------------  
-- X_Display Event Dispatch Vectors  
------------------------------------------------------------------------------  

    subtype X_Event_Wire_Array is D3.X_Event_Wire_Array;  
    ----Array of X_Event_Wire_Type;  

    subtype X_Wire_Event_Array is D3.X_Wire_Event_Array;  
    ----Array of X_Wire_Event_Type;  


------------------------------------------------------------------------------  
-- X_Reply_S_Natural - Size of a reply based upon the request that got it.  
------------------------------------------------------------------------------  

    subtype X_Reply_S_Natural is D3.X_Reply_S_Natural;  

end Xlbt_Display2;  

