with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Basic3;  
use Xlbt_Basic3;  
with Xlbt_Context_Manager3;  
use Xlbt_Context_Manager3;  
with Xlbt_Event3;  
use Xlbt_Event3;  
with Xlbt_Extension3;  
use Xlbt_Extension3;  
with Xlbt_Extension4;  
use Xlbt_Extension4;  
with Xlbt_Gc3;  
use Xlbt_Gc3;  
with Xlbt_Graphics3;  
use Xlbt_Graphics3;  
with Xlbt_Image;  
use Xlbt_Image;  
with Xlbt_Key3;  
use Xlbt_Key3;  
with Xlbt_Proc_Var;  
use Xlbt_Proc_Var;  
with Xlbt_Request3;  
use Xlbt_Request3;  
with Xlbt_String;  
use Xlbt_String;  
with Xlbt_Window4;  
use Xlbt_Window4;  
with Xlbt_Univ_Ptr;  
use Xlbt_Univ_Ptr;  
with Xlbt_Visual;  
use Xlbt_Visual;  

with Xlbmt_Network_Types;  
use Xlbmt_Network_Types;  
with Xlbmt_Parameters;  
use Xlbmt_Parameters;  

package body Xlbt_Display3 is  
------------------------------------------------------------------------------  
-- X Library Display - Full Interface  
--  
-- Xlbt_Display3 - Types that need not be imported directly into most programs.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure Err (Destination : out X_Error_String;  
                   Source      :     X_String) is  
------------------------------------------------------------------------------  
----We use this routine to assign error strings.  
--  We pad the buffer with Ascii.Nul's.  
------------------------------------------------------------------------------  
    begin  
        if Source'Length > Destination.Ary'Length then  
            Destination.Ary :=  
               Source (Source'First ..  
                          Source'First + Destination.Ary'Length - 1);  
        else  
            Destination.Ary (Destination.Ary'First ..  
                                Destination.Ary'First + Source'Length - 1) :=  
               Source (Source'Range);  
            Destination.Ary (Destination.Ary'First + Source'Length ..  
                                Destination.Ary'Last)                      :=  
               (others => Xlbt_String.Nul);  
        end if;  
    end Err;  

--
    function Err (Source : X_Error_String) return X_String is  
------------------------------------------------------------------------------  
----We use this function to read out error strings.  
--  Return everything up to the first null.  
------------------------------------------------------------------------------  
    begin  
        for I in Source.Ary'Range loop  
            if Source.Ary (I) = Xlbt_String.Nul then  
                return Source.Ary (Source.Ary'First .. I - 1);  
            end if;  
        end loop;  
        return Source.Ary;  
    end Err;  

--
end Xlbt_Display3;  

