with Xlbt_Event3;  

package Xlbt_Event2 is  
------------------------------------------------------------------------------  
-- X Library Protocol Event Codes and Packets - Extended User Interface  
--  
-- Xlbt_Event2 - Record definitions of the protocol event packets  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

    package E3 renames Xlbt_Event3;  
--
------------------------------------------------------------------------------  
-- X_Colormap_State - Color Map notification  
------------------------------------------------------------------------------  

    subtype X_Colormap_State is E3.X_Colormap_State;  

    Colormap_Uninstalled : constant X_Colormap_State := E3.Colormap_Uninstalled;  
    Colormap_Installed   : constant X_Colormap_State := E3.Colormap_Installed;  

    None_X_Colormap_State : X_Colormap_State renames E3.None_X_Colormap_State;  

    function "=" (A, B : X_Colormap_State) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Enter/Leave Notify detail  
------------------------------------------------------------------------------  

    subtype X_Enter_Leave_Detail is E3.X_Enter_Leave_Detail;  

    Enter_Leave_Notify_Ancestor          : constant X_Enter_Leave_Detail  
        := E3.Enter_Leave_Notify_Ancestor;  
    Enter_Leave_Notify_Virtual           : constant X_Enter_Leave_Detail  
        := E3.Enter_Leave_Notify_Virtual;  
    Enter_Leave_Notify_Inferior          : constant X_Enter_Leave_Detail  
        := E3.Enter_Leave_Notify_Inferior;  
    Enter_Leave_Notify_Nonlinear         : constant X_Enter_Leave_Detail  
        := E3.Enter_Leave_Notify_Nonlinear;  
    Enter_Leave_Notify_Nonlinear_Virtual : constant X_Enter_Leave_Detail  
        := E3.Enter_Leave_Notify_Nonlinear_Virtual;  

    None_X_Enter_Leave_Detail : X_Enter_Leave_Detail  
        renames E3.None_X_Enter_Leave_Detail;  

    function "=" (A, B : X_Enter_Leave_Detail) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Enter/Leave flags  
------------------------------------------------------------------------------  

    subtype X_Enter_Leave_Flags_Index is E3.X_Enter_Leave_Flags_Index;  

    subtype Xelfi is X_Enter_Leave_Flags_Index;  

    Enter_Leave_Same_Screen : constant Xelfi := E3.Enter_Leave_Same_Screen;  
    Enter_Leave_Focus       : constant Xelfi := E3.Enter_Leave_Focus;  

    subtype X_Enter_Leave_Flags is E3.X_Enter_Leave_Flags;  

    None_X_Enter_Leave_Flags : X_Enter_Leave_Flags  
        renames E3.None_X_Enter_Leave_Flags;  

    function "=" (A, B : Xelfi)               return Boolean renames E3."=";  
    function "=" (A, B : X_Enter_Leave_Flags) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Enter/Leave mode  
------------------------------------------------------------------------------  

    subtype X_Enter_Leave_Mode is E3.X_Enter_Leave_Mode;  

    Enter_Leave_Notify_Normal : constant X_Enter_Leave_Mode  
        := E3.Enter_Leave_Notify_Normal;  
    Enter_Leave_Notify_Grab   : constant X_Enter_Leave_Mode  
        := E3.Enter_Leave_Notify_Grab;  
    Enter_Leave_Notify_Ungrab : constant X_Enter_Leave_Mode  
        := E3.Enter_Leave_Notify_Ungrab;  

    None_X_Enter_Leave_Mode : X_Enter_Leave_Mode  
        renames E3.None_X_Enter_Leave_Mode;  

    function "=" (A, B : X_Enter_Leave_Mode) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Focus In/Out detail  
------------------------------------------------------------------------------  

    subtype X_Focus_Detail is E3.X_Focus_Detail;  

    Focus_Notify_Ancestor          : constant X_Focus_Detail  
        := E3.Focus_Notify_Ancestor;  
    Focus_Notify_Virtual           : constant X_Focus_Detail  
        := E3.Focus_Notify_Virtual;  
    Focus_Notify_Inferior          : constant X_Focus_Detail  
        := E3.Focus_Notify_Inferior;  
    Focus_Notify_Nonlinear         : constant X_Focus_Detail  
        := E3.Focus_Notify_Nonlinear;  
    Focus_Notify_Nonlinear_Virtual : constant X_Focus_Detail  
        := E3.Focus_Notify_Nonlinear_Virtual;  
    Focus_Notify_Pointer           : constant X_Focus_Detail  
        := E3.Focus_Notify_Pointer;  
    Focus_Notify_Pointer_Root      : constant X_Focus_Detail  
        := E3.Focus_Notify_Pointer_Root;  
    Focus_Notify_Detail_None       : constant X_Focus_Detail  
        := E3.Focus_Notify_Detail_None;  

    None_X_Focus_Detail : X_Focus_Detail renames E3.None_X_Focus_Detail;  

    function "=" (A, B : X_Focus_Detail) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Focus In/Out mode  
------------------------------------------------------------------------------  

    subtype X_Focus_Mode is E3.X_Focus_Mode;  

    Focus_Notify_Normal        : constant X_Focus_Mode  
        := E3.Focus_Notify_Normal;  
    Focus_Notify_Grab          : constant X_Focus_Mode  
        := E3.Focus_Notify_Grab;  
    Focus_Notify_Ungrab        : constant X_Focus_Mode  
        := E3.Focus_Notify_Ungrab;  
    Focus_Notify_While_Grabbed : constant X_Focus_Mode  
        := E3.Focus_Notify_While_Grabbed;  

    None_X_Focus_Mode : X_Focus_Mode renames E3.None_X_Focus_Mode;  

    function "=" (A, B : X_Focus_Mode) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Mapping Notify Request  
------------------------------------------------------------------------------  

    subtype X_Mapping_Request_Type is E3.X_Mapping_Request_Type;  

    Mapping_Modifier : constant X_Mapping_Request_Type := E3.Mapping_Modifier;  
    Mapping_Keyboard : constant X_Mapping_Request_Type := E3.Mapping_Keyboard;  
    Mapping_Pointer  : constant X_Mapping_Request_Type := E3.Mapping_Pointer;  

    None_X_Mapping_Request_Type : X_Mapping_Request_Type  
        renames E3.None_X_Mapping_Request_Type;  

    function "=" (A, B : X_Mapping_Request_Type) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Motion Notify detail  
------------------------------------------------------------------------------  

    subtype X_Motion_Notify_Detail is E3.X_Motion_Notify_Detail;  

    Motion_Notify_Normal : constant X_Motion_Notify_Detail  
        := E3.Motion_Notify_Normal;  
    Motion_Notify_Hint   : constant X_Motion_Notify_Detail  
        := E3.Motion_Notify_Hint;  

    None_X_Motion_Notify_Detail : X_Motion_Notify_Detail  
        renames E3.None_X_Motion_Notify_Detail;  

    function "=" (A, B : X_Motion_Notify_Detail) return Boolean renames E3."=";  

------------------------------------------------------------------------------  
-- Visibility notify state  
------------------------------------------------------------------------------  

    subtype X_Visibility_Notify_State is E3.X_Visibility_Notify_State;  

    Visibility_Unobscured         : constant X_Visibility_Notify_State  
        := E3.Visibility_Unobscured;  
    Visibility_Partially_Obscured : constant X_Visibility_Notify_State  
        := E3.Visibility_Partially_Obscured;  
    Visibility_Fully_Obscured     : constant X_Visibility_Notify_State  
        := E3.Visibility_Fully_Obscured;  

    None_X_Visibility_Notify_State : X_Visibility_Notify_State  
        renames E3.None_X_Visibility_Notify_State;  

    function "=" (A, B : X_Visibility_Notify_State) return Boolean  
        renames E3."=";  

--
------------------------------------------------------------------------------  
-- Extensions record events using these types.  
------------------------------------------------------------------------------  

    subtype X_Universal_Pointer_Event is E3.X_Universal_Pointer_Event;  

    subtype X_Extension_Event_Kind is E3.X_Extension_Event_Kind;  

    function "=" (A, B : X_Extension_Event_Kind) return Boolean renames E3."=";  

    subtype Xeev is X_Extension_Event_Kind;  

    Key_Event               : constant Xeev := E3.Key_Event;  
    Button_Event            : constant Xeev := E3.Button_Event;  
    Motion_Event            : constant Xeev := E3.Motion_Event;  
    Enter_Leave_Event       : constant Xeev := E3.Enter_Leave_Event;  
    Focus_Event             : constant Xeev := E3.Focus_Event;  
    Keymap_Event            : constant Xeev := E3.Keymap_Event;  
    Expose_Event            : constant Xeev := E3.Expose_Event;  
    Graphics_Expose_Event   : constant Xeev := E3.Graphics_Expose_Event;  
    No_Expose_Event         : constant Xeev := E3.No_Expose_Event;  
    Visibility_Event        : constant Xeev := E3.Visibility_Event;  
    Create_Event            : constant Xeev := E3.Create_Event;  
    Destroy_Event           : constant Xeev := E3.Destroy_Event;  
    Unmap_Event             : constant Xeev := E3.Unmap_Event;  
    Map_Event               : constant Xeev := E3.Map_Event;  
    Map_Request_Event       : constant Xeev := E3.Map_Request_Event;  
    Reparent_Event          : constant Xeev := E3.Reparent_Event;  
    Configure_Event         : constant Xeev := E3.Configure_Event;  
    Configure_Request_Event : constant Xeev := E3.Configure_Request_Event;  
    Gravity_Event           : constant Xeev := E3.Gravity_Event;  
    Resize_Request_Event    : constant Xeev := E3.Resize_Request_Event;  
    Circulate_Event         : constant Xeev := E3.Circulate_Event;  
    Circulate_Request_Event : constant Xeev := E3.Circulate_Request_Event;  
    Property_Event          : constant Xeev := E3.Property_Event;  
    Selection_Clear_Event   : constant Xeev := E3.Selection_Clear_Event;  
    Selection_Event         : constant Xeev := E3.Selection_Event;  
    Selection_Request_Event : constant Xeev := E3.Selection_Request_Event;  
    Colormap_Event          : constant Xeev := E3.Colormap_Event;  
    Client_Event            : constant Xeev := E3.Client_Event;  
    Mapping_Event           : constant Xeev := E3.Mapping_Event;  
    Universal_Pointer_Event : constant Xeev := E3.Universal_Pointer_Event;  

    subtype X_Extension_Event is E3.X_Extension_Event;  

--
end Xlbt_Event2;  

