package Xlbt_Exceptions is  
------------------------------------------------------------------------------  
-- X Library Exceptions  
--  
-- Xlbt_Exceptions - Exceptions generated by the X Library.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    X_Network_Io_Error : exception;  
    ----An error occurred during an attempt to Receive/Transmit on the network.  
    --  The default handler reports the error to the error log and then  
    -- raises this exception.  

    X_Unhandled_Error : exception;  
    ----An Error event occurred and no user handler was set up.  The default  
    --  error handler reports the error to the error log and then raises this  
    --  exception.  

    X_Invalid_Procedure_Variable : exception;  
    ----Raised when an attempt to convert a value of the "generic"  
    --  X_Procedure_Variable type is being converted to a specific procedure  
    --  variable type and this is invalid.  Meaning that the parameter  
    --  profile of the procedure and of the specific procedure variable type  
    --  do not match.  

    X_Bad_Procedure_Variable : exception;  
    ----Raised when some procedure variable operation is performed upon  
    --  a) a None_X_Procedure_Variable value (an actual value is required),  
    --  b) an inappropriate procedure variable value (the value is for a  
    --     procedure with a different parameter profile), or,  
    --  c) a "bad" procedure variable is used (one example is a dynamic  
    --     procedure that is referenced but is not longer available, it may  
    --     not be possible to detect this in all cases).  

    X_Invalid_Universal_Pointer : exception;  
    ----Raised when some universal pointer operation is performed upon  
    --  a) a None_X_Universal_Pointer value (an actual value is required),  
    --  b) an inappropriate universal pointer value (a value cannot be  
    --     converted to the requested Access_Type), or,  
    --  c) a previously freed universal pointer value is referenced (it may  
    --     not be possible to detect this in all cases).  

    X_Library_Confusion : exception;  
    ----The X Library is in some place or in some state that it is not prepared  
    --  to handle.  This is probably a bug of some kind, not necessarily a bug  
    --  within the X Library itself; it could be a bug in the X Server or even  
    --  in the application.  This is only raised in those situations where  
    --  the X Library must throw up its hands and appeal to higher authority.  

end Xlbt_Exceptions;  

