with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package body Xlbt_Extension3 is  
------------------------------------------------------------------------------  
-- X Library Extensions - Full Interface Part 1  
--  
-- Xlbt_Extension3 - Types dealing with extensions to the X Library and to  
-- the X Protocol.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure Free_X_Extension_List (List : in out X_Extension) is  
------------------------------------------------------------------------------  
-- Free up an X_Extension list; presumably hung off an X_Display.  
------------------------------------------------------------------------------  
    begin  

----Make sure that we exist.  

        if List = None_X_Extension then  
            return;  
        end if;  

----Since we are part of a list; free up the rest of the list first.  

        if List.Next /= null then  
            Free_X_Extension_List (List.Next);  
        end if;  

----Now free ourselves.  

        Free_X_Extension (List);  

    end Free_X_Extension_List;  


--
end Xlbt_Extension3;  

