with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_Proc_Var;  
use Xlbt_Proc_Var;  
with Xlbt_Univ_Ptr;  
use Xlbt_Univ_Ptr;  

with Xlbp_Proc_Var;  
use Xlbp_Proc_Var;  

package body Xlbt_Extension4 is  
------------------------------------------------------------------------------  
-- X Library Extensions - Full Interface Part 2  
--  
-- Xlbt_Extension4 - Types dealing with extensions to the X Library and to  
-- the X Protocol.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure Free_X_Ext_Data_List (List : in out X_Ext_Data) is  
    begin  

----If this isn't the last of the Extension data areas then free the .Next one  
--  first.  

        if List = null then  
            return;  
        end if;  
        if List.Next /= null then  
            Free_X_Ext_Data_List (List.Next);  
        end if;  

----If there actually is .Private_Data then free it with .Free_Private.  

        if List.Private_Data /= None_X_Universal_Pointer and then  
           List.Free_Private /= None_X_Procedure_Variable then  
            Proc_Var_X_Free_Extension_Data.Call  
               (Proc_Var_X_Free_Extension_Data.To_Pv (List.Free_Private),  
                List.Private_Data);  
        end if;  

----Free up the extension record itself.  

        Free_X_Ext_Data (List);  

    end Free_X_Ext_Data_List;  
--
end Xlbt_Extension4;  

