with Xlbt_Gc3;  

package Xlbt_Gc is  
------------------------------------------------------------------------------  
-- X Library Graphics Contexts - Normal User Interface  
--  
-- Xlbt_Gc - Types related to Graphics Contexts (X_Gc's)  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package G3 renames Xlbt_Gc3;  

------------------------------------------------------------------------------  
-- X_Arc_Mode  
--  
--      Arc_Chord       - join endpoints of arc  
--      Arc_Pie_Slice   - join endpoints to center of arc  
------------------------------------------------------------------------------  

    subtype X_Arc_Mode is G3.X_Arc_Mode;  

    Arc_Chord     : constant X_Arc_Mode := G3.Arc_Chord;  
    Arc_Pie_Slice : constant X_Arc_Mode := G3.Arc_Pie_Slice;  

    None_X_Arc_Mode : X_Arc_Mode renames G3.None_X_Arc_Mode;  

    function "=" (A, B : X_Arc_Mode) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Best_Size_Class  
--  
--      Cursor_Shape    - largest size that can be displayed  
--      Tile_Shape      - size tiled fastest  
--      Stipple_Shape   - size stippled fastest  
------------------------------------------------------------------------------  

    subtype X_Best_Size_Class is G3.X_Best_Size_Class;  

    Cursor_Shape  : constant X_Best_Size_Class := G3.Cursor_Shape;  
    Tile_Shape    : constant X_Best_Size_Class := G3.Tile_Shape;  
    Stipple_Shape : constant X_Best_Size_Class := G3.Stipple_Shape;  

    function "=" (A, B : X_Best_Size_Class) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Cap_Style  
--  
--      Cap_Not_Last  
--      Cap_Butt  
--      Cap_Round  
--      Cap_Projecting  
------------------------------------------------------------------------------  

    subtype X_Cap_Style is G3.X_Cap_Style;  

    Cap_Not_Last   : constant X_Cap_Style := G3.Cap_Not_Last;  
    Cap_Butt       : constant X_Cap_Style := G3.Cap_Butt;  
    Cap_Round      : constant X_Cap_Style := G3.Cap_Round;  
    Cap_Projecting : constant X_Cap_Style := G3.Cap_Projecting;  

    None_X_Cap_Style : X_Cap_Style renames G3.None_X_Cap_Style;  

    function "=" (A, B : X_Cap_Style) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Clip_Ordering  
--  
--      Unsorted  
--      Y_Sorted  
--      Y_X_Sorted  
--      Y_X_Banded  
------------------------------------------------------------------------------  

    subtype X_Clip_Ordering is G3.X_Clip_Ordering;  

    Unsorted   : constant X_Clip_Ordering := G3.Unsorted;  
    Y_Sorted   : constant X_Clip_Ordering := G3.Y_Sorted;  
    Y_X_Sorted : constant X_Clip_Ordering := G3.Y_X_Sorted;  
    Y_X_Banded : constant X_Clip_Ordering := G3.Y_X_Banded;  

    None_X_Clip_Ordering : X_Clip_Ordering renames G3.None_X_Clip_Ordering;  

    function "=" (A, B : X_Clip_Ordering) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Fill_Rule  
--  
--      Even_Odd_Rule  
--      Winding_Rule  
------------------------------------------------------------------------------  

    subtype X_Fill_Rule is G3.X_Fill_Rule;  

    Even_Odd_Rule : constant X_Fill_Rule := G3.Even_Odd_Rule;  
    Winding_Rule  : constant X_Fill_Rule := G3.Winding_Rule;  

    None_X_Fill_Rule : X_Fill_Rule renames G3.None_X_Fill_Rule;  

    function "=" (A, B : X_Fill_Rule) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Fill_Style  
--  
--      Fill_Solid  
--      Fill_Tiled  
--      Fill_Stippled  
--      Fill_Opaque_Stippled  
------------------------------------------------------------------------------  

    subtype X_Fill_Style is G3.X_Fill_Style;  

    Fill_Solid           : constant X_Fill_Style := G3.Fill_Solid;  
    Fill_Tiled           : constant X_Fill_Style := G3.Fill_Tiled;  
    Fill_Stippled        : constant X_Fill_Style := G3.Fill_Stippled;  
    Fill_Opaque_Stippled : constant X_Fill_Style := G3.Fill_Opaque_Stippled;  

    None_X_Fill_Style : constant X_Fill_Style := X_Fill_Style'Val (0);  

    function "=" (A, B : X_Fill_Style) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Gc_Components - masks used in X_Create_Gc, X_Copy_Gc, X_Change_Gc,  
-- OR'ed into GC.State_Changes  
--  
--      Gc_Arc_Mode  
--      Gc_Dash_List  
--      Gc_Dash_Offset  
--      Gc_Clip_Mask  
--      Gc_Clip_Y_Origin  
--      Gc_Clip_X_Origin  
--      Gc_Graphics_Exposures  
--      Gc_Subwindow_Mode  
--      Gc_Font  
--      Gc_Tile_Stip_Y_Origin  
--      Gc_Tile_Stip_X_Origin  
--      Gc_Stipple  
--      Gc_Tile  
--      Gc_Fill_Rule  
--      Gc_Fill_Style  
--      Gc_Join_Style  
--      Gc_Cap_Style  
--      Gc_Line_Style  
--      Gc_Line_Width  
--      Gc_Background  
--      Gc_Foreground  
--      Gc_Plane_Mask  
--      Gc_Function  
--  
--      Gc_Last_Bit - "highest" bit used; Gc_Function is the "first" bit used.  
------------------------------------------------------------------------------  

    subtype X_Gc_Components_Index is G3.X_Gc_Components_Index;  
    subtype X_Gc_Components       is G3.X_Gc_Components;  

    Gc_Last_Bit          : X_Gc_Components_Index renames G3.Gc_Last_Bit;  
    None_X_Gc_Components : X_Gc_Components renames G3.None_X_Gc_Components;  
    All_Gc_Components    : X_Gc_Components renames G3.All_Gc_Components;  

    subtype Xgci is X_Gc_Components_Index;  

    Gc_Arc_Mode           : constant Xgci := G3.Gc_Arc_Mode;  
    Gc_Dash_List          : constant Xgci := G3.Gc_Dash_List;  
    Gc_Dash_Offset        : constant Xgci := G3.Gc_Dash_Offset;  
    Gc_Clip_Mask          : constant Xgci := G3.Gc_Clip_Mask;  
    Gc_Clip_Y_Origin      : constant Xgci := G3.Gc_Clip_Y_Origin;  
    Gc_Clip_X_Origin      : constant Xgci := G3.Gc_Clip_X_Origin;  
    Gc_Graphics_Exposures : constant Xgci := G3.Gc_Graphics_Exposures;  
    Gc_Subwindow_Mode     : constant Xgci := G3.Gc_Subwindow_Mode;  
    Gc_Font               : constant Xgci := G3.Gc_Font;  
    Gc_Tile_Stip_Y_Origin : constant Xgci := G3.Gc_Tile_Stip_Y_Origin;  
    Gc_Tile_Stip_X_Origin : constant Xgci := G3.Gc_Tile_Stip_X_Origin;  
    Gc_Stipple            : constant Xgci := G3.Gc_Stipple;  
    Gc_Tile               : constant Xgci := G3.Gc_Tile;  
    Gc_Fill_Rule          : constant Xgci := G3.Gc_Fill_Rule;  
    Gc_Fill_Style         : constant Xgci := G3.Gc_Fill_Style;  
    Gc_Join_Style         : constant Xgci := G3.Gc_Join_Style;  
    Gc_Cap_Style          : constant Xgci := G3.Gc_Cap_Style;  
    Gc_Line_Style         : constant Xgci := G3.Gc_Line_Style;  
    Gc_Line_Width         : constant Xgci := G3.Gc_Line_Width;  
    Gc_Background         : constant Xgci := G3.Gc_Background;  
    Gc_Foreground         : constant Xgci := G3.Gc_Foreground;  
    Gc_Plane_Mask         : constant Xgci := G3.Gc_Plane_Mask;  
    Gc_Function           : constant Xgci := G3.Gc_Function;  

    function "=" (A, B : X_Gc_Components_Index) return Boolean renames G3."=";  
    function "=" (A, B : X_Gc_Components)       return Boolean renames G3."=";  

    subtype Xgcc is X_Gc_Components;  

    function "and" (A, B : Xgcc) return X_Gc_Components renames G3."and";  
    function "or"  (A, B : Xgcc) return X_Gc_Components renames G3."or";  
    function "xor" (A, B : Xgcc) return X_Gc_Components renames G3."xor";  
    function "not" (A : Xgcc)    return X_Gc_Components renames G3."not";  

------------------------------------------------------------------------------  
-- X_Gc_Values - Graphic data structure for setting a Graphics Context.  
------------------------------------------------------------------------------  

    subtype X_Gc_Values is G3.X_Gc_Values;  

    None_X_Gc_Values : X_Gc_Values renames G3.None_X_Gc_Values;  

------------------------------------------------------------------------------  
-- X_Graphic_Function  
--  
--      Gx_Clear         - 0  
--      Gx_And           - src AND dst  
--      Gx_And_Reverse   - src AND NOT dst  
--      Gx_Copy          - src  
--      Gx_And_Inverted  - NOT src AND dst  
--      Gx_Noop          - dst  
--      Gx_Xor           - src XOR dst  
--      Gx_Or            - src OR dst  
--      Gx_Nor           - NOT src AND NOT dst  
--      Gx_Equiv         - NOT src X_OR dst  
--      Gx_Invert        - NOT dst  
--      Gx_Or_Reverse    - src OR NOT dst  
--      Gx_Copy_Inverted - NOT src  
--      Gx_Or_Inverted   - NOT src OR dst  
--      Gx_Nand          - NOT src OR NOT dst  
--      Gx_Set           - 1  
------------------------------------------------------------------------------  

    subtype X_Graphic_Function is G3.X_Graphic_Function;  

    Gx_Clear         : constant X_Graphic_Function := G3.Gx_Clear;  
    Gx_And           : constant X_Graphic_Function := G3.Gx_And;  
    Gx_And_Reverse   : constant X_Graphic_Function := G3.Gx_And_Reverse;  
    Gx_Copy          : constant X_Graphic_Function := G3.Gx_Copy;  
    Gx_And_Inverted  : constant X_Graphic_Function := G3.Gx_And_Inverted;  
    Gx_Noop          : constant X_Graphic_Function := G3.Gx_Noop;  
    Gx_Xor           : constant X_Graphic_Function := G3.Gx_Xor;  
    Gx_Or            : constant X_Graphic_Function := G3.Gx_Or;  
    Gx_Nor           : constant X_Graphic_Function := G3.Gx_Nor;  
    Gx_Equiv         : constant X_Graphic_Function := G3.Gx_Equiv;  
    Gx_Invert        : constant X_Graphic_Function := G3.Gx_Invert;  
    Gx_Or_Reverse    : constant X_Graphic_Function := G3.Gx_Or_Reverse;  
    Gx_Copy_Inverted : constant X_Graphic_Function := G3.Gx_Copy_Inverted;  
    Gx_Or_Inverted   : constant X_Graphic_Function := G3.Gx_Or_Inverted;  
    Gx_Nand          : constant X_Graphic_Function := G3.Gx_Nand;  
    Gx_Set           : constant X_Graphic_Function := G3.Gx_Set;  

    None_X_Graphic_Function : X_Graphic_Function  
        renames G3.None_X_Graphic_Function;  

    function "=" (A, B : X_Graphic_Function) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Join_Style  
--  
--      Join_Miter  
--      Join_Round  
--      Join_Bevel  
------------------------------------------------------------------------------  

    subtype X_Join_Style is G3.X_Join_Style;  

    Join_Miter : constant X_Join_Style := G3.Join_Miter;  
    Join_Round : constant X_Join_Style := G3.Join_Round;  
    Join_Bevel : constant X_Join_Style := G3.Join_Bevel;  

    None_X_Join_Style : X_Join_Style renames G3.None_X_Join_Style;  

    function "=" (A, B : X_Join_Style) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Line_Style  
--  
--      Line_Solid  
--      Line_On_Off_Dash  
--      Line_Double_Dash  
------------------------------------------------------------------------------  

    subtype X_Line_Style is G3.X_Line_Style;  

    Line_Solid       : constant X_Line_Style := G3.Line_Solid;  
    Line_On_Off_Dash : constant X_Line_Style := G3.Line_On_Off_Dash;  
    Line_Double_Dash : constant X_Line_Style := G3.Line_Double_Dash;  

    None_X_Line_Style : X_Line_Style renames G3.None_X_Line_Style;  

    function "=" (A, B : X_Line_Style) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Subwindow_Mode  
--  
--      Clip_By_Children  
--      Include_Inferiors  
------------------------------------------------------------------------------  

    subtype X_Subwindow_Mode is G3.X_Subwindow_Mode;  

    Clip_By_Children  : constant X_Subwindow_Mode := G3.Clip_By_Children;  
    Include_Inferiors : constant X_Subwindow_Mode := G3.Include_Inferiors;  

    None_X_Subwindow_Mode : X_Subwindow_Mode renames G3.None_X_Subwindow_Mode;  

    function "=" (A, B : X_Subwindow_Mode) return Boolean renames G3."=";  

end Xlbt_Gc;  

