with Xlbt_Graphics3;  

package Xlbt_Graphics is  
------------------------------------------------------------------------------  
-- X Library Graphics - Normal User Interface  
--  
-- Xlbp_Graphics - Draw various types of things on a window  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

    package G3 renames Xlbt_Graphics3;  

--
------------------------------------------------------------------------------  
-- X_Arc - Description of Arcs  
------------------------------------------------------------------------------  

    subtype X_Arc       is G3.X_Arc;  
    subtype X_Arc_Array is G3.X_Arc_Array;  
    subtype X_Arc_List  is G3.X_Arc_List;  

    None_X_Arc      : X_Arc      renames G3.None_X_Arc;  
    None_X_Arc_List : X_Arc_List renames G3.None_X_Arc_List;  

    function  "="             (A, B : X_Arc)      return Boolean renames G3."=";  
    function  "="             (A, B : X_Arc_List) return Boolean renames G3."=";  
    procedure Free_X_Arc_List (List : in out X_Arc_List)  
        renames G3.Free_X_Arc_List;  

------------------------------------------------------------------------------  
-- X_Coordinate_Mode for drawing routines  
--  
--  Coord_Mode_Origin   - relative to the origin  
--  Coord_Mode_Previous - relative to previous point  
------------------------------------------------------------------------------  

    subtype X_Coordinate_Mode is G3.X_Coordinate_Mode;  

    Coord_Mode_Origin   : constant X_Coordinate_Mode := G3.Coord_Mode_Origin;  
    Coord_Mode_Previous : constant X_Coordinate_Mode := G3.Coord_Mode_Previous;  

    None_X_Coordinate_Mode : X_Coordinate_Mode  
        renames G3.None_X_Coordinate_Mode;  

    function "=" (A, B : X_Coordinate_Mode) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Point - Points in X  
------------------------------------------------------------------------------  

    subtype X_Point       is G3.X_Point;  
    subtype X_Point_Array is G3.X_Point_Array;  
    subtype X_Point_List  is G3.X_Point_List;  

    None_X_Point      : X_Point      renames G3.None_X_Point;  
    None_X_Point_List : X_Point_List renames G3.None_X_Point_List;  

    function  "=" (A, B : X_Point) return Boolean renames G3."=";  
    function  "=" (A, B : X_Point_List) return Boolean renames G3."=";  
    procedure Free_X_Point_List (List : in out X_Point_List)  
        renames G3.Free_X_Point_List;  

------------------------------------------------------------------------------  
-- X_Polygon_Shape  
--  
--  Complex     - paths may intersect  
--  Nonconvex   - no paths intersect, but not convex  
--  Convex      - wholly convex  
------------------------------------------------------------------------------  

    subtype X_Polygon_Shape is G3.X_Polygon_Shape;  

    Complex   : constant X_Polygon_Shape := G3.Complex;  
    Nonconvex : constant X_Polygon_Shape := G3.Nonconvex;  
    Convex    : constant X_Polygon_Shape := G3.Convex;  

    None_X_Polygon_Shape : X_Polygon_Shape renames G3.None_X_Polygon_Shape;  

    function "=" (A, B : X_Polygon_Shape) return Boolean renames G3."=";  

------------------------------------------------------------------------------  
-- X_Rectangle  
------------------------------------------------------------------------------  

    subtype X_Rectangle       is G3.X_Rectangle;  
    subtype X_Rectangle_Array is G3.X_Rectangle_Array;  
    subtype X_Rectangle_List  is G3.X_Rectangle_List;  

    None_X_Rectangle      : X_Rectangle      renames G3.None_X_Rectangle;  
    None_X_Rectangle_List : X_Rectangle_List renames G3.None_X_Rectangle_List;  

    function  "=" (A, B : X_Rectangle) return Boolean renames G3."=";  
    function  "=" (A, B : X_Rectangle_List) return Boolean renames G3."=";  
    procedure Free_X_Rectangle_List (List : in out X_Rectangle_List)  
        renames G3.Free_X_Rectangle_List;  

------------------------------------------------------------------------------  
-- X_Segment - Line Segment  
------------------------------------------------------------------------------  

    subtype X_Segment       is G3.X_Segment;  
    subtype X_Segment_Array is G3.X_Segment_Array;  
    subtype X_Segment_List  is G3.X_Segment_List;  

    None_X_Segment      : X_Segment      renames G3.None_X_Segment;  
    None_X_Segment_List : X_Segment_List renames G3.None_X_Segment_List;  

    function "=" (A, B : X_Segment)      return Boolean renames G3."=";  
    function "=" (A, B : X_Segment_List) return Boolean renames G3."=";  

    procedure Free_X_Segment_List (List : in out X_Segment_List)  
        renames G3.Free_X_Segment_List;  

end Xlbt_Graphics;  

