with Xlbt_Host3;  

package Xlbt_Host is  
------------------------------------------------------------------------------  
-- X Library Host Computer Controls - Normal User Interface  
--  
-- Xlbt_Host - Structures used to (un)authorize host/application connections  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

    package H3 renames Xlbt_Host3;  

--
------------------------------------------------------------------------------  
-- X_Change_Access  
------------------------------------------------------------------------------  

    subtype X_Change_Access is H3.X_Change_Access;  

    Disable_Access : constant X_Change_Access := H3.Disable_Access;  
    Enable_Access  : constant X_Change_Access := H3.Enable_Access;  

    function "=" (A, B : X_Change_Access) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Change_Hosts_Mode  
------------------------------------------------------------------------------  

    subtype X_Change_Hosts_Mode is H3.X_Change_Hosts_Mode;  

    Host_Insert : constant X_Change_Hosts_Mode := H3.Host_Insert;  
    Host_Delete : constant X_Change_Hosts_Mode := H3.Host_Delete;  

    function "=" (A, B : X_Change_Hosts_Mode) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Change_Save_Set_Mode  
------------------------------------------------------------------------------  

    subtype X_Change_Save_Set_Mode is H3.X_Change_Save_Set_Mode;  

    Set_Mode_Insert : constant X_Change_Save_Set_Mode := H3.Set_Mode_Insert;  
    Set_Mode_Delete : constant X_Change_Save_Set_Mode := H3.Set_Mode_Delete;  

    function "=" (A, B : X_Change_Save_Set_Mode) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Close_Down_Mode  
------------------------------------------------------------------------------  

    subtype X_Close_Down_Mode is H3.X_Close_Down_Mode;  

    Destroy_All      : constant X_Close_Down_Mode := H3.Destroy_All;  
    Retain_Permanent : constant X_Close_Down_Mode := H3.Retain_Permanent;  
    Retain_Temporary : constant X_Close_Down_Mode := H3.Retain_Temporary;  

    function "=" (A, B : X_Close_Down_Mode) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Host_Protocol_Family  
------------------------------------------------------------------------------  

    subtype X_Host_Protocol_Family is H3.X_Host_Protocol_Family;  

    Family_Internet : constant X_Host_Protocol_Family := H3.Family_Internet;  
    Family_Decnet   : constant X_Host_Protocol_Family := H3.Family_Decnet;  
    Family_Chaos    : constant X_Host_Protocol_Family := H3.Family_Chaos;  

    None_X_Host_Protocol_Family : X_Host_Protocol_Family  
        renames H3.None_X_Host_Protocol_Family;  

    function "=" (A, B : X_Host_Protocol_Family) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Host_Address - holds the "address" of a host  
------------------------------------------------------------------------------  

    subtype X_Host_Address       is H3.X_Host_Address;  
    subtype X_Host_Address_Array is H3.X_Host_Address_Array;  

    None_X_Host_Address : X_Host_Address renames H3.None_X_Host_Address;  

    function "=" (A, B : X_Host_Address) return Boolean renames H3."=";  

------------------------------------------------------------------------------  
-- X_Host_Address_List - holds the "address" of several hosts  
------------------------------------------------------------------------------  

    subtype X_Host_Address_List is H3.X_Host_Address_List;  

    None_X_Host_Address_List : X_Host_Address_List  
        renames H3.None_X_Host_Address_List;  

    function "=" (A, B : X_Host_Address_List) return Boolean renames H3."=";  

    procedure Free_X_Host_Address_List (List : in out X_Host_Address_List)  
        renames H3.Free_X_Host_Address_List;  

------------------------------------------------------------------------------  
-- X_Host_List  
------------------------------------------------------------------------------  

    subtype X_Host_List is H3.X_Host_List;  

    None_X_Host_List : X_Host_List renames H3.None_X_Host_List;  

    procedure Free_X_Host_List (List : in out X_Host_List)  
        renames H3.Free_X_Host_List;  

end Xlbt_Host;  

