with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  
with Xlbt_String;  
use Xlbt_String;  

package Xlbt_Host3 is  
------------------------------------------------------------------------------  
-- X Library Host Computer Controls - Full Interface  
--  
-- Xlbt_Host3 - Structures used to (un)authorize host/application connections  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
-- X_Change_Access  
------------------------------------------------------------------------------  

    type X_Change_Access is (Disable_Access,  
                             Enable_Access);  

--/ if Length_Clauses then  
    for X_Change_Access'Size use 8;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Change_Hosts_Mode  
------------------------------------------------------------------------------  

    type X_Change_Hosts_Mode is (Host_Insert,  
                                 Host_Delete);  

--/ if Length_Clauses then  
    for X_Change_Hosts_Mode'Size use 8;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Change_Save_Set_Mode  
------------------------------------------------------------------------------  

    type X_Change_Save_Set_Mode is (Set_Mode_Insert,  
                                    Set_Mode_Delete);  

--/ if Length_Clauses then  
    for X_Change_Save_Set_Mode'Size use 8;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Close_Down_Mode  
------------------------------------------------------------------------------  

    type X_Close_Down_Mode is (Destroy_All,  
                               Retain_Permanent,  
                               Retain_Temporary);  

--/ if Length_Clauses then  
    for X_Close_Down_Mode'Size use 8;  
--/ end if;  

------------------------------------------------------------------------------  
-- X_Host_Protocol_Family  
------------------------------------------------------------------------------  

    type X_Host_Protocol_Family is (Family_Internet,  
                                    Family_Decnet,  
                                    Family_Chaos);  

--/ if Length_Clauses then  
    for X_Host_Protocol_Family'Size use 8;  
--/ end if;  

    None_X_Host_Protocol_Family : constant X_Host_Protocol_Family :=  
       X_Host_Protocol_Family'Val (0);  

------------------------------------------------------------------------------  
-- X_Host_Address - holds the "address" of a host  
------------------------------------------------------------------------------  

    type X_Host_Address is  
        record  
            Family  : X_Host_Protocol_Family := None_X_Host_Protocol_Family;  
            Address : X_String_Pointer       := None_X_String_Pointer;  
            ----Network Address  
        end record;  

    type X_Host_Address_Array is array (S_Positive range <>) of X_Host_Address;  
    type X_Host_Address_List  is access X_Host_Address_Array;  

--/ if Pack then  
    pragma Pack (X_Host_Address_Array);  
--/ end if;  
--/ if Enable_Deallocation then  
    pragma Enable_Deallocation (X_Host_Address_List);  
--/ end if;  

    None_X_Host_Address      : constant X_Host_Address      :=  
       (None_X_Host_Protocol_Family, None_X_String_Pointer);  
    None_X_Host_Address_List : constant X_Host_Address_List := null;  

    procedure Free_X_Host_Address_List (List : in out X_Host_Address_List);  

------------------------------------------------------------------------------  
-- X_Host_List  
------------------------------------------------------------------------------  

    type X_Host_List is  
        record  
            Enabled : Boolean;  
            List    : X_Host_Address_List;  
        end record;  

    None_X_Host_List : constant X_Host_List :=  
       (False, None_X_Host_Address_List);  

    procedure Free_X_Host_List (List : in out X_Host_List);  

end Xlbt_Host3;  

