with Xlbt_Image3;  

package Xlbt_Image is  
------------------------------------------------------------------------------  
-- X Library Image - Normal User Interface  
--  
-- Xlbt_Image - Screen/Window Images  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    package I3 renames Xlbt_Image3;  

------------------------------------------------------------------------------  
-- X_Byte_Bit_Order  
--  
--      Lsb_First       - least-significant-first  
--      Msb_First       - most-significant-first  
------------------------------------------------------------------------------  

    subtype X_Byte_Bit_Order is I3.X_Byte_Bit_Order;  

    Lsb_First : constant X_Byte_Bit_Order := I3.Lsb_First;  
    Msb_First : constant X_Byte_Bit_Order := I3.Msb_First;  

    None_X_Byte_Bit_Order : X_Byte_Bit_Order renames I3.None_X_Byte_Bit_Order;  

    function "=" (A, B : X_Byte_Bit_Order) return Boolean renames I3."=";  

------------------------------------------------------------------------------  
-- X_Image_Format  
--  
--      X_Y_Bitmap  - depth 1, X_Y_Format  
--      X_Y_Pixmap  - depth == drawable depth  
--      Z_Pixmap    - depth == drawable depth  
------------------------------------------------------------------------------  

    subtype X_Image_Format is I3.X_Image_Format;  

    X_Y_Bitmap : constant X_Image_Format := I3.X_Y_Bitmap;  
    X_Y_Pixmap : constant X_Image_Format := I3.X_Y_Pixmap;  
    Z_Pixmap   : constant X_Image_Format := I3.Z_Pixmap;  

    None_X_Image_Format : X_Image_Format renames I3.None_X_Image_Format;  

    function "=" (A, B : X_Image_Format) return Boolean renames I3."=";  

------------------------------------------------------------------------------  
-- X_Pixmap_Format_Values  
------------------------------------------------------------------------------  

    subtype X_Pixmap_Format_Values      is I3.X_Pixmap_Format_Values;  
    subtype X_Pixmap_Format_Values_List is I3.X_Pixmap_Format_Values_List;  

    None_X_Pixmap_Format_Values      : X_Pixmap_Format_Values  
        renames I3.None_X_Pixmap_Format_Values;  
    None_X_Pixmap_Format_Values_List : X_Pixmap_Format_Values_List  
        renames I3.None_X_Pixmap_Format_Values_List;  

    procedure Free_X_Pixmap_Format_Values_List  
                 (List : in out X_Pixmap_Format_Values_List)  
        renames I3.Free_X_Pixmap_Format_Values_List;  

------------------------------------------------------------------------------  
-- X_Image - Image data structure  
------------------------------------------------------------------------------  

    subtype X_Image is I3.X_Image;  

    None_X_Image : X_Image renames I3.None_X_Image;  

    function "=" (A, B : X_Image) return Boolean renames I3."=";  

    procedure Free_X_Image (Image : in out X_Image) renames I3.Free_X_Image;  

end Xlbt_Image;  

