with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package body Xlbt_Image3 is  
------------------------------------------------------------------------------  
-- X Library Image - Full Interface  
--  
-- Xlbt_Image3 - Screen/Window Images  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1987 - 1989 by Digital Equipment Corporation, Maynard, Mass.  
-- Copyright 1987 - 1989 by Massachusetts Institute of Technology,  
--                          Cambridge, Massachusetts.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of Digital, MIT, or Rational  
-- not be used in advertising or publicity pertaining to distribution of  
-- the software without specific, written prior permission.  
--  
-- Digital, MIT, and Rational disclaim all warranties with regard to this  
-- software, including all implied warranties of merchantability and fitness,  
-- in no event shall Digital, MIT, or Rational be liable for any special,  
-- indirect or consequential damages or any damages whatsoever resulting from  
-- loss of use, data or profits, whether in an action of contract, negligence  
-- or other tortious action, arising out of or in connection with the use or  
-- performance of this software.  
------------------------------------------------------------------------------  

--
    procedure Heap_Free_X_Image is new Unchecked_Deallocation (X_Image_Rec,  
                                                               X_Image);  

--
    procedure Free_X_Image (Image : in out X_Image) is  
    begin  

        if Image = None_X_Image then  
            return;  
        end if;  
        if not Image.Data_Is_Shared then  
            Free_U_Char_List (Image.Data);  
        end if;  
        Free_U_Char_List (Image.Obdata);  
        Heap_Free_X_Image (Image);  

    end Free_X_Image;  

--
end Xlbt_Image3;  

