with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Latin2 is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Latin2  
--  
-- Xlbt_Key_Defs_Latin2 - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
--   Latin 2  
--   Byte 3 = 1  
------------------------------------------------------------------------------  

    Xk_S_Aogonek      : constant X_Key_Sym := 16#01A1#; -- XK_Aogonek  
    Xk_Breve          : constant X_Key_Sym := 16#01A2#; -- XK_breve  
    Xk_S_Lstroke      : constant X_Key_Sym := 16#01A3#; -- XK_Lstroke  
    Xk_S_Lcaron       : constant X_Key_Sym := 16#01A5#; -- XK_Lcaron  
    Xk_S_Sacute       : constant X_Key_Sym := 16#01A6#; -- XK_Sacute  
    Xk_S_Scaron       : constant X_Key_Sym := 16#01A9#; -- XK_Scaron  
    Xk_S_Scedilla     : constant X_Key_Sym := 16#01AA#; -- XK_Scedilla  
    Xk_S_Tcaron       : constant X_Key_Sym := 16#01AB#; -- XK_Tcaron  
    Xk_S_Zacute       : constant X_Key_Sym := 16#01AC#; -- XK_Zacute  
    Xk_S_Zcaron       : constant X_Key_Sym := 16#01AE#; -- XK_Zcaron  
    Xk_S_Zabovedot    : constant X_Key_Sym := 16#01AF#; -- XK_Zabovedot  
    Xk_Aogonek        : constant X_Key_Sym := 16#01B1#; -- XK_aogonek  
    Xk_Ogonek         : constant X_Key_Sym := 16#01B2#; -- XK_ogonek  
    Xk_Lstroke        : constant X_Key_Sym := 16#01B3#; -- XK_lstroke  
    Xk_Lcaron         : constant X_Key_Sym := 16#01B5#; -- XK_lcaron  
    Xk_Sacute         : constant X_Key_Sym := 16#01B6#; -- XK_sacute  
    Xk_Caron          : constant X_Key_Sym := 16#01B7#; -- XK_caron  
    Xk_Scaron         : constant X_Key_Sym := 16#01B9#; -- XK_scaron  
    Xk_Scedilla       : constant X_Key_Sym := 16#01BA#; -- XK_scedilla  
    Xk_Tcaron         : constant X_Key_Sym := 16#01BB#; -- XK_tcaron  
    Xk_Zacute         : constant X_Key_Sym := 16#01BC#; -- XK_zacute  
    Xk_Doubleacute    : constant X_Key_Sym := 16#01BD#; -- XK_doubleacute  
    Xk_Zcaron         : constant X_Key_Sym := 16#01BE#; -- XK_zcaron  
    Xk_Zabovedot      : constant X_Key_Sym := 16#01BF#; -- XK_zabovedot  
    Xk_S_Racute       : constant X_Key_Sym := 16#01C0#; -- XK_Racute  
    Xk_S_Abreve       : constant X_Key_Sym := 16#01C3#; -- XK_Abreve  
    Xk_S_Lacute       : constant X_Key_Sym := 16#01C5#; -- XK_Lacute  
    Xk_S_Cacute       : constant X_Key_Sym := 16#01C6#; -- XK_Cacute  
    Xk_S_Ccaron       : constant X_Key_Sym := 16#01C8#; -- XK_Ccaron  
    Xk_S_Eogonek      : constant X_Key_Sym := 16#01CA#; -- XK_Eogonek  
    Xk_S_Ecaron       : constant X_Key_Sym := 16#01CC#; -- XK_Ecaron  
    Xk_S_Dcaron       : constant X_Key_Sym := 16#01CF#; -- XK_Dcaron  
    Xk_S_Dstroke      : constant X_Key_Sym := 16#01D0#; -- XK_Dstroke  
    Xk_S_Nacute       : constant X_Key_Sym := 16#01D1#; -- XK_Nacute  
    Xk_S_Ncaron       : constant X_Key_Sym := 16#01D2#; -- XK_Ncaron  
    Xk_S_Odoubleacute : constant X_Key_Sym := 16#01D5#; -- XK_Odoubleacute  
    Xk_S_Rcaron       : constant X_Key_Sym := 16#01D8#; -- XK_Rcaron  
    Xk_S_Uring        : constant X_Key_Sym := 16#01D9#; -- XK_Uring  
    Xk_S_Udoubleacute : constant X_Key_Sym := 16#01DB#; -- XK_Udoubleacute  
    Xk_S_Tcedilla     : constant X_Key_Sym := 16#01DE#; -- XK_Tcedilla  
    Xk_Racute         : constant X_Key_Sym := 16#01E0#; -- XK_racute  
    Xk_Abreve         : constant X_Key_Sym := 16#01E3#; -- XK_abreve  
    Xk_Lacute         : constant X_Key_Sym := 16#01E5#; -- XK_lacute  
    Xk_Cacute         : constant X_Key_Sym := 16#01E6#; -- XK_cacute  
    Xk_Ccaron         : constant X_Key_Sym := 16#01E8#; -- XK_ccaron  
    Xk_Eogonek        : constant X_Key_Sym := 16#01EA#; -- XK_eogonek  
    Xk_Ecaron         : constant X_Key_Sym := 16#01EC#; -- XK_ecaron  
    Xk_Dcaron         : constant X_Key_Sym := 16#01EF#; -- XK_dcaron  
    Xk_Dstroke        : constant X_Key_Sym := 16#01F0#; -- XK_dstroke  
    Xk_Nacute         : constant X_Key_Sym := 16#01F1#; -- XK_nacute  
    Xk_Ncaron         : constant X_Key_Sym := 16#01F2#; -- XK_ncaron  
    Xk_Odoubleacute   : constant X_Key_Sym := 16#01F5#; -- XK_odoubleacute  
    Xk_Udoubleacute   : constant X_Key_Sym := 16#01FB#; -- XK_udoubleacute  
    Xk_Rcaron         : constant X_Key_Sym := 16#01F8#; -- XK_rcaron  
    Xk_Uring          : constant X_Key_Sym := 16#01F9#; -- XK_uring  
    Xk_Tcedilla       : constant X_Key_Sym := 16#01FE#; -- XK_tcedilla  
    Xk_Abovedot       : constant X_Key_Sym := 16#01FF#; -- XK_abovedot  

end Xlbt_Key_Defs_Latin2;  

