with Xlbt_Key;  
use Xlbt_Key;  

package Xlbt_Key_Defs_Publishing is  
------------------------------------------------------------------------------  
-- X Library Key Symbol Definitions - Publishing  
--  
-- Xlbt_Key_Defs_Publishing - Definitions of the various pre-defined X Key Symbols  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
------------------------------------------------------------------------------  
--  Publishing  
--  Byte 3 = a  
------------------------------------------------------------------------------  

    Xk_Emspace              : constant X_Key_Sym := 16#0AA1#;  
    Xk_Enspace              : constant X_Key_Sym := 16#0AA2#;  
    Xk_Em3space             : constant X_Key_Sym := 16#0AA3#;  
    Xk_Em4space             : constant X_Key_Sym := 16#0AA4#;  
    Xk_Digitspace           : constant X_Key_Sym := 16#0AA5#;  
    Xk_Punctspace           : constant X_Key_Sym := 16#0AA6#;  
    Xk_Thinspace            : constant X_Key_Sym := 16#0AA7#;  
    Xk_Hairspace            : constant X_Key_Sym := 16#0AA8#;  
    Xk_Emdash               : constant X_Key_Sym := 16#0AA9#;  
    Xk_Endash               : constant X_Key_Sym := 16#0AAA#;  
    Xk_Signifblank          : constant X_Key_Sym := 16#0AAC#;  
    Xk_Ellipsis             : constant X_Key_Sym := 16#0AAE#;  
    Xk_Doubbaselinedot      : constant X_Key_Sym := 16#0AAF#;  
    Xk_Onethird             : constant X_Key_Sym := 16#0AB0#;  
    Xk_Twothirds            : constant X_Key_Sym := 16#0AB1#;  
    Xk_Onefifth             : constant X_Key_Sym := 16#0AB2#;  
    Xk_Twofifths            : constant X_Key_Sym := 16#0AB3#;  
    Xk_Threefifths          : constant X_Key_Sym := 16#0AB4#;  
    Xk_Fourfifths           : constant X_Key_Sym := 16#0AB5#;  
    Xk_Onesixth             : constant X_Key_Sym := 16#0AB6#;  
    Xk_Fivesixths           : constant X_Key_Sym := 16#0AB7#;  
    Xk_Careof               : constant X_Key_Sym := 16#0AB8#;  
    Xk_Figdash              : constant X_Key_Sym := 16#0ABB#;  
    Xk_Leftanglebracket     : constant X_Key_Sym := 16#0ABC#;  
    Xk_Decimalpoint         : constant X_Key_Sym := 16#0ABD#;  
    Xk_Rightanglebracket    : constant X_Key_Sym := 16#0ABE#;  
    Xk_Marker               : constant X_Key_Sym := 16#0ABF#;  
    Xk_Oneeighth            : constant X_Key_Sym := 16#0AC3#;  
    Xk_Threeeighths         : constant X_Key_Sym := 16#0AC4#;  
    Xk_Fiveeighths          : constant X_Key_Sym := 16#0AC5#;  
    Xk_Seveneighths         : constant X_Key_Sym := 16#0AC6#;  
    Xk_Trademark            : constant X_Key_Sym := 16#0AC9#;  
    Xk_Signaturemark        : constant X_Key_Sym := 16#0ACA#;  
    Xk_Trademarkincircle    : constant X_Key_Sym := 16#0ACB#;  
    Xk_Leftopentriangle     : constant X_Key_Sym := 16#0ACC#;  
    Xk_Rightopentriangle    : constant X_Key_Sym := 16#0ACD#;  
    Xk_Emopencircle         : constant X_Key_Sym := 16#0ACE#;  
    Xk_Emopenrectangle      : constant X_Key_Sym := 16#0ACF#;  
    Xk_Leftsinglequotemark  : constant X_Key_Sym := 16#0AD0#;  
    Xk_Rightsinglequotemark : constant X_Key_Sym := 16#0AD1#;  
    Xk_Leftdoublequotemark  : constant X_Key_Sym := 16#0AD2#;  
    Xk_Rightdoublequotemark : constant X_Key_Sym := 16#0AD3#;  
    Xk_Prescription         : constant X_Key_Sym := 16#0AD4#;  
    Xk_Minutes              : constant X_Key_Sym := 16#0AD6#;  
    Xk_Seconds              : constant X_Key_Sym := 16#0AD7#;  
    Xk_Latincross           : constant X_Key_Sym := 16#0AD9#;  
    Xk_Hexagram             : constant X_Key_Sym := 16#0ADA#;  
    Xk_Filledrectbullet     : constant X_Key_Sym := 16#0ADB#;  
    Xk_Filledlefttribullet  : constant X_Key_Sym := 16#0ADC#;  
    Xk_Filledrighttribullet : constant X_Key_Sym := 16#0ADD#;  
    Xk_Emfilledcircle       : constant X_Key_Sym := 16#0ADE#;  
    Xk_Emfilledrect         : constant X_Key_Sym := 16#0ADF#;  
    Xk_Enopencircbullet     : constant X_Key_Sym := 16#0AE0#;  
    Xk_Enopensquarebullet   : constant X_Key_Sym := 16#0AE1#;  
    Xk_Openrectbullet       : constant X_Key_Sym := 16#0AE2#;  
    Xk_Opentribulletup      : constant X_Key_Sym := 16#0AE3#;  
    Xk_Opentribulletdown    : constant X_Key_Sym := 16#0AE4#;  
    Xk_Openstar             : constant X_Key_Sym := 16#0AE5#;  
    Xk_Enfilledcircbullet   : constant X_Key_Sym := 16#0AE6#;  
    Xk_Enfilledsqbullet     : constant X_Key_Sym := 16#0AE7#;  
    Xk_Filledtribulletup    : constant X_Key_Sym := 16#0AE8#;  
    Xk_Filledtribulletdown  : constant X_Key_Sym := 16#0AE9#;  
    Xk_Leftpointer          : constant X_Key_Sym := 16#0AEA#;  
    Xk_Rightpointer         : constant X_Key_Sym := 16#0AEB#;  
    Xk_Club                 : constant X_Key_Sym := 16#0AEC#;  
    Xk_Diamond              : constant X_Key_Sym := 16#0AED#;  
    Xk_Heart                : constant X_Key_Sym := 16#0AEE#;  
    Xk_Maltesecross         : constant X_Key_Sym := 16#0AF0#;  
    Xk_Dagger               : constant X_Key_Sym := 16#0AF1#;  
    Xk_Doubledagger         : constant X_Key_Sym := 16#0AF2#;  
    Xk_Checkmark            : constant X_Key_Sym := 16#0AF3#;  
    Xk_Ballotcross          : constant X_Key_Sym := 16#0AF4#;  
    Xk_Musicalsharp         : constant X_Key_Sym := 16#0AF5#;  
    Xk_Musicalflat          : constant X_Key_Sym := 16#0AF6#;  
    Xk_Malesymbol           : constant X_Key_Sym := 16#0AF7#;  
    Xk_Femalesymbol         : constant X_Key_Sym := 16#0AF8#;  
    Xk_Telephone            : constant X_Key_Sym := 16#0AF9#;  
    Xk_Telephonerecorder    : constant X_Key_Sym := 16#0AFA#;  
    Xk_Phonographcopyright  : constant X_Key_Sym := 16#0AFB#;  
    Xk_Caret                : constant X_Key_Sym := 16#0AFC#;  
    Xk_Singlelowquotemark   : constant X_Key_Sym := 16#0AFD#;  
    Xk_Doublelowquotemark   : constant X_Key_Sym := 16#0AFE#;  
    Xk_Cursor               : constant X_Key_Sym := 16#0AFF#;  

end Xlbt_Key_Defs_Publishing;  

