with Xlbt_Key3;  

package Xlbt_Key2 is  
------------------------------------------------------------------------------  
-- X Library Key Codes, Symbols, and Translations - Extended User Interface  
--  
-- Xlbt_Key2 - Types and structures used to describe and keep track of keys  
-- on the keyboard.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package K3 renames Xlbt_Key3;  

------------------------------------------------------------------------------  
-- X_Key_Sym_Array  
------------------------------------------------------------------------------  

    subtype X_Key_Sym_List is K3.X_Key_Sym_List;  

    None_X_Key_Sym_List : X_Key_Sym_List renames K3.None_X_Key_Sym_List;  

    function "=" (A, B : X_Key_Sym_List) return Boolean renames K3."=";  

    procedure Free_X_Key_Sym_List (List : in out X_Key_Sym_List)  
        renames K3.Free_X_Key_Sym_List;  

---------------------------------------------------------------------------------  
-- X_Key_Trans  
------------------------------------------------------------------------------  

    subtype X_Key_Trans_Rec is K3.X_Key_Trans_Rec;  
    subtype X_Key_Trans     is K3.X_Key_Trans;  

    None_X_Key_Trans : X_Key_Trans renames K3.None_X_Key_Trans;  


    function "=" (A, B : X_Key_Trans) return Boolean renames K3."=";  

    procedure Free_X_Key_Trans (Kt : in out X_Key_Trans)  
        renames K3.Free_X_Key_Trans;  

    procedure Free_X_Key_Trans_List (Kt : in out X_Key_Trans)  
        renames K3.Free_X_Key_Trans_List;  

------------------------------------------------------------------------------  
-- X_Modifier_Key_Code_List  
------------------------------------------------------------------------------  

    subtype X_Modifier_Key_Code_Sub_Array is K3.X_Modifier_Key_Code_Sub_Array;  
    subtype X_Modifier_Key_Code_Array     is K3.X_Modifier_Key_Code_Array;  
    subtype X_Modifier_Key_Code_List      is K3.X_Modifier_Key_Code_List;  

    function "=" (A, B : X_Modifier_Key_Code_List) return Boolean  
        renames K3."=";  

    procedure Free_X_Modifier_Key_Code_List  
                 (List : in out X_Modifier_Key_Code_List)  
        renames K3.Free_X_Modifier_Key_Code_List;  

------------------------------------------------------------------------------  
-- X_Modifier_Keymap  
------------------------------------------------------------------------------  

    subtype X_Modifier_Keymap_Rec is K3.X_Modifier_Keymap_Rec;  

end Xlbt_Key2;  

