with Unchecked_Deallocation;  

with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

package body Xlbt_Key3 is  
------------------------------------------------------------------------------  
-- X Library Key Codes, Symbols, and Translations  
--  
-- Xlbt_Key2 - Types and structures used to describe and keep track of keys  
-- on the keyboard.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    procedure Heap_Free_X_Key_Trans is  
       new Unchecked_Deallocation (X_Key_Trans_Rec,  
                                   X_Key_Trans);  

    procedure Heap_Free_X_Modifier_Keymap is  
       new Unchecked_Deallocation (X_Modifier_Keymap_Rec,  
                                   X_Modifier_Keymap);  

--
    procedure Free_X_Key_Trans (Kt : in out X_Key_Trans) is  
    begin  
        if Kt = None_X_Key_Trans then  
            return;  
        end if;  
        Free_X_String_Pointer (Kt.Str);  
        Free_X_Key_Sym_List (Kt.Modifiers);  
        Heap_Free_X_Key_Trans (Kt);  
    end Free_X_Key_Trans;  

--
    procedure Free_X_Key_Trans_List (Kt : in out X_Key_Trans) is  
        K1 : X_Key_Trans;  
        K2 : X_Key_Trans;  
    begin  
        K1 := Kt;  
        while K1 /= null loop  
            K2 := K1.Next;  
            Free_X_Key_Trans (K1);  
            K1 := K2;  
        end loop;  
    end Free_X_Key_Trans_List;  

--
    procedure Free_X_Modifier_Keymap (Map : in out X_Modifier_Keymap) is  
    begin  

        if Map /= None_X_Modifier_Keymap then  
            Free_X_Modifier_Key_Code_List (Map.Modifiermap);  
            Heap_Free_X_Modifier_Keymap (Map);  
        end if;  

    end Free_X_Modifier_Keymap;  

--
end Xlbt_Key3;  

