with Xlbt_Arithmetic;  
use Xlbt_Arithmetic;  

with Xlbp_U_Char_Converters;  
use Xlbp_U_Char_Converters;  

package body Xlbt_Misc is  
------------------------------------------------------------------------------  
-- X Library Misc Types  
--  
-- Xlbt_Misc - Types that used for protocol messages and other odd things.  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    function To_Boolean (B : X_Boolean_Char) return Boolean is  
    begin  
        if B = True then  
            return True;  
        else  
            return False;  
        end if;  
    end To_Boolean;  

--
    function From_Boolean (B : Boolean) return X_Boolean_Char is  
    begin  
        if B then  
            return True;  
        else  
            return False;  
        end if;  
    end From_Boolean;  

--
    function To_Boolean (B : X_Boolean_Long) return Boolean is  
    begin  
        if B = True then  
            return True;  
        else  
            return False;  
        end if;  
    end To_Boolean;  

--
    function From_Boolean (B : Boolean) return X_Boolean_Long is  
    begin  
        if B then  
            return True;  
        else  
            return False;  
        end if;  
    end From_Boolean;  

--
    function X_Client_Message_S_Char (Xe    : X_Client_Data_Type;  
                                      Index : S_Natural_0_19) return S_Char is  
        Data : S_Char;  
    begin  
        From_Uca (Data, U_Char_Array (Xe (Index .. Index)));  
        return Data;  
    end X_Client_Message_S_Char;  

--
    function X_Client_Message_S_Short (Xe    : X_Client_Data_Type;  
                                       Index : S_Natural_0_9) return S_Short is  
        Data : S_Short;  
    begin  
        From_Uca (Data, U_Char_Array (Xe (Index * 2 .. Index * 2 + 1)));  
        return Data;  
    end X_Client_Message_S_Short;  

--
    function X_Client_Message_S_Long (Xe    : X_Client_Data_Type;  
                                      Index : S_Natural_0_4) return S_Long is  
        Data : S_Long;  
    begin  
        From_Uca (Data, U_Char_Array (Xe (Index * 4 .. Index * 4 + 3)));  
        return Data;  
    end X_Client_Message_S_Long;  

--
    function X_Client_Message_U_Char (Xe    : X_Client_Data_Type;  
                                      Index : S_Natural_0_19) return U_Char is  
    begin  
        return Xe (Index);  
    end X_Client_Message_U_Char;  

--
    function X_Client_Message_U_Short (Xe    : X_Client_Data_Type;  
                                       Index : S_Natural_0_9) return U_Short is  
        Data : U_Short;  
    begin  
        From_Uca (Data, U_Char_Array (Xe (Index * 2 .. Index * 2 + 1)));  
        return Data;  
    end X_Client_Message_U_Short;  

--
    procedure X_Client_Message_S_Char (Xe    : in out X_Client_Data_Type;  
                                       Index :        S_Natural_0_19;  
                                       Data  :        S_Char) is  
    begin  
        To_Uca (U_Char_Array (Xe (Index .. Index)), Data);  
    end X_Client_Message_S_Char;  

--
    procedure X_Client_Message_S_Short (Xe    : in out X_Client_Data_Type;  
                                        Index :        S_Natural_0_9;  
                                        Data  :        S_Short) is  
    begin  
        To_Uca (U_Char_Array (Xe (Index * 2 .. Index * 2 + 1)), Data);  
    end X_Client_Message_S_Short;  

--
    procedure X_Client_Message_S_Long (Xe    : in out X_Client_Data_Type;  
                                       Index :        S_Natural_0_4;  
                                       Data  :        S_Long) is  
    begin  
        To_Uca (U_Char_Array (Xe (Index * 4 .. Index * 4 + 3)), Data);  
    end X_Client_Message_S_Long;  

--
    procedure X_Client_Message_U_Char (Xe    : in out X_Client_Data_Type;  
                                       Index :        S_Natural_0_19;  
                                       Data  :        U_Char) is  
    begin  
        Xe (Index) := Data;  
    end X_Client_Message_U_Char;  

--
    procedure X_Client_Message_U_Short (Xe    : in out X_Client_Data_Type;  
                                        Index :        S_Natural_0_9;  
                                        Data  :        U_Short) is  
    begin  
        To_Uca (U_Char_Array (Xe (Index * 2 .. Index * 2 + 1)), Data);  
    end X_Client_Message_U_Short;  

--
end Xlbt_Misc;  

