with Xlbt_Request3;  

package Xlbt_Request is  
------------------------------------------------------------------------------  
-- X Library Protocol Request Codes and Packets - Normal User Interface  
--  
-- Xlbt_Request - Record definitions of the protocol request packets  
------------------------------------------------------------------------------  
-- Copyright 1989 - 1991 by Rational, Santa Clara, California.  
-- Copyright 1985 - 1989 by the Massachusetts Institute of Technology  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the names of MIT or Rational not be  
-- used in advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- MIT and Rational disclaim all warranties with regard to this software,  
-- including all implied warranties of merchantability and fitness, in no  
-- event shall MIT or Rational be liable for any special, indirect or  
-- consequential damages or any damages whatsoever resulting from loss of use,  
-- data or profits, whether in an action of contract, negligence or other  
-- tortious action, arising out of or in connection with the use or performance  
-- of this software.  
------------------------------------------------------------------------------  

--
    package R3 renames Xlbt_Request3;  

--
------------------------------------------------------------------------------  
-- X_Request_Code - X Protocol Request Codes  
------------------------------------------------------------------------------  

    subtype X_Request_Code is R3.X_Request_Code;  

    function "=" (A, B : X_Request_Code) return Boolean renames R3."=";  

    subtype Xrc is X_Request_Code;  

    Invalid_Request            : constant Xrc := R3.Invalid_Request;  
    Create_Window              : constant Xrc := R3.Create_Window;  
    Change_Window_Attributes   : constant Xrc := R3.Change_Window_Attributes;  
    Get_Window_Attributes      : constant Xrc := R3.Get_Window_Attributes;  
    Destroy_Window             : constant Xrc := R3.Destroy_Window;  
    Destroy_Subwindows         : constant Xrc := R3.Destroy_Subwindows;  
    Change_Save_Set            : constant Xrc := R3.Change_Save_Set;  
    Reparent_Window            : constant Xrc := R3.Reparent_Window;  
    Map_Window                 : constant Xrc := R3.Map_Window;  
    Map_Subwindows             : constant Xrc := R3.Map_Subwindows;  
    Unmap_Window               : constant Xrc := R3.Unmap_Window;  
    Unmap_Subwindows           : constant Xrc := R3.Unmap_Subwindows;  
    Configure_Window           : constant Xrc := R3.Configure_Window;  
    Circulate_Window           : constant Xrc := R3.Circulate_Window;  
    Get_Geometry               : constant Xrc := R3.Get_Geometry;  
    Query_Tree                 : constant Xrc := R3.Query_Tree;  
    Intern_Atom                : constant Xrc := R3.Intern_Atom;  
    Get_Atom_Name              : constant Xrc := R3.Get_Atom_Name;  
    Change_Property            : constant Xrc := R3.Change_Property;  
    Delete_Property            : constant Xrc := R3.Delete_Property;  
    Get_Property               : constant Xrc := R3.Get_Property;  
    List_Properties            : constant Xrc := R3.List_Properties;  
    Set_Selection_Owner        : constant Xrc := R3.Set_Selection_Owner;  
    Get_Selection_Owner        : constant Xrc := R3.Get_Selection_Owner;  
    Convert_Selection          : constant Xrc := R3.Convert_Selection;  
    Send_Event                 : constant Xrc := R3.Send_Event;  
    Grab_Pointer               : constant Xrc := R3.Grab_Pointer;  
    Ungrab_Pointer             : constant Xrc := R3.Ungrab_Pointer;  
    Grab_Button                : constant Xrc := R3.Grab_Button;  
    Ungrab_Button              : constant Xrc := R3.Ungrab_Button;  
    Change_Active_Pointer_Grab : constant Xrc := R3.Change_Active_Pointer_Grab;  
    Grab_Keyboard              : constant Xrc := R3.Grab_Keyboard;  
    Ungrab_Keyboard            : constant Xrc := R3.Ungrab_Keyboard;  
    Grab_Key                   : constant Xrc := R3.Grab_Key;  
    Ungrab_Key                 : constant Xrc := R3.Ungrab_Key;  
    Allow_Events               : constant Xrc := R3.Allow_Events;  
    Grab_Server                : constant Xrc := R3.Grab_Server;  
    Ungrab_Server              : constant Xrc := R3.Ungrab_Server;  
    Query_Pointer              : constant Xrc := R3.Query_Pointer;  
    Get_Motion_Events          : constant Xrc := R3.Get_Motion_Events;  
    Translate_Coords           : constant Xrc := R3.Translate_Coords;  
    Warp_Pointer               : constant Xrc := R3.Warp_Pointer;  
    Set_Input_Focus            : constant Xrc := R3.Set_Input_Focus;  
    Get_Input_Focus            : constant Xrc := R3.Get_Input_Focus;  
    Query_Keymap               : constant Xrc := R3.Query_Keymap;  
    Open_Font                  : constant Xrc := R3.Open_Font;  
    Close_Font                 : constant Xrc := R3.Close_Font;  
    Query_Font                 : constant Xrc := R3.Query_Font;  
    Query_Text_Extents         : constant Xrc := R3.Query_Text_Extents;  
    List_Fonts                 : constant Xrc := R3.List_Fonts;  
    List_Fonts_With_Info       : constant Xrc := R3.List_Fonts_With_Info;  
    Set_Font_Path              : constant Xrc := R3.Set_Font_Path;  
    Get_Font_Path              : constant Xrc := R3.Get_Font_Path;  
    Create_Pixmap              : constant Xrc := R3.Create_Pixmap;  
    Free_Pixmap                : constant Xrc := R3.Free_Pixmap;  
    Create_Gc                  : constant Xrc := R3.Create_Gc;  
    Change_Gc                  : constant Xrc := R3.Change_Gc;  
    Copy_Gc                    : constant Xrc := R3.Copy_Gc;  
    Set_Dashes                 : constant Xrc := R3.Set_Dashes;  
    Set_Clip_Rectangles        : constant Xrc := R3.Set_Clip_Rectangles;  
    Free_Gc                    : constant Xrc := R3.Free_Gc;  
    Clear_Area                 : constant Xrc := R3.Clear_Area;  
    Copy_Area                  : constant Xrc := R3.Copy_Area;  
    Copy_Plane                 : constant Xrc := R3.Copy_Plane;  
    Poly_Point                 : constant Xrc := R3.Poly_Point;  
    Poly_Line                  : constant Xrc := R3.Poly_Line;  
    Poly_Segment               : constant Xrc := R3.Poly_Segment;  
    Poly_Rectangle             : constant Xrc := R3.Poly_Rectangle;  
    Poly_Arc                   : constant Xrc := R3.Poly_Arc;  
    Fill_Poly                  : constant Xrc := R3.Fill_Poly;  
    Poly_Fill_Rectangle        : constant Xrc := R3.Poly_Fill_Rectangle;  
    Poly_Fill_Arc              : constant Xrc := R3.Poly_Fill_Arc;  
    Put_Image                  : constant Xrc := R3.Put_Image;  
    Get_Image                  : constant Xrc := R3.Get_Image;  
    Poly_Text8                 : constant Xrc := R3.Poly_Text8;  
    Poly_Text16                : constant Xrc := R3.Poly_Text16;  
    Image_Text8                : constant Xrc := R3.Image_Text8;  
    Image_Text16               : constant Xrc := R3.Image_Text16;  
    Create_Colormap            : constant Xrc := R3.Create_Colormap;  
    Free_Colormap              : constant Xrc := R3.Free_Colormap;  
    Copy_Colormap_And_Free     : constant Xrc := R3.Copy_Colormap_And_Free;  
    Install_Colormap           : constant Xrc := R3.Install_Colormap;  
    Uninstall_Colormap         : constant Xrc := R3.Uninstall_Colormap;  
    List_Installed_Colormaps   : constant Xrc := R3.List_Installed_Colormaps;  
    Alloc_Color                : constant Xrc := R3.Alloc_Color;  
    Alloc_Named_Color          : constant Xrc := R3.Alloc_Named_Color;  
    Alloc_Color_Cells          : constant Xrc := R3.Alloc_Color_Cells;  
    Alloc_Color_Planes         : constant Xrc := R3.Alloc_Color_Planes;  
    Free_Colors                : constant Xrc := R3.Free_Colors;  
    Store_Colors               : constant Xrc := R3.Store_Colors;  
    Store_Named_Color          : constant Xrc := R3.Store_Named_Color;  
    Query_Colors               : constant Xrc := R3.Query_Colors;  
    Lookup_Color               : constant Xrc := R3.Lookup_Color;  
    Create_Cursor              : constant Xrc := R3.Create_Cursor;  
    Create_Glyph_Cursor        : constant Xrc := R3.Create_Glyph_Cursor;  
    Free_Cursor                : constant Xrc := R3.Free_Cursor;  
    Recolor_Cursor             : constant Xrc := R3.Recolor_Cursor;  
    Query_Best_Size            : constant Xrc := R3.Query_Best_Size;  
    Query_Extension            : constant Xrc := R3.Query_Extension;  
    List_Extensions            : constant Xrc := R3.List_Extensions;  
    Change_Keyboard_Mapping    : constant Xrc := R3.Change_Keyboard_Mapping;  
    Get_Keyboard_Mapping       : constant Xrc := R3.Get_Keyboard_Mapping;  
    Change_Keyboard_Control    : constant Xrc := R3.Change_Keyboard_Control;  
    Get_Keyboard_Control       : constant Xrc := R3.Get_Keyboard_Control;  
    Bell                       : constant Xrc := R3.Bell;  
    Change_Pointer_Control     : constant Xrc := R3.Change_Pointer_Control;  
    Get_Pointer_Control        : constant Xrc := R3.Get_Pointer_Control;  
    Set_Screen_Saver           : constant Xrc := R3.Set_Screen_Saver;  
    Get_Screen_Saver           : constant Xrc := R3.Get_Screen_Saver;  
    Change_Hosts               : constant Xrc := R3.Change_Hosts;  
    List_Hosts                 : constant Xrc := R3.List_Hosts;  
    Set_Access_Control         : constant Xrc := R3.Set_Access_Control;  
    Set_Close_Down_Mode        : constant Xrc := R3.Set_Close_Down_Mode;  
    Kill_Client                : constant Xrc := R3.Kill_Client;  
    Rotate_Properties          : constant Xrc := R3.Rotate_Properties;  
    Force_Screen_Saver         : constant Xrc := R3.Force_Screen_Saver;  
    Set_Pointer_Mapping        : constant Xrc := R3.Set_Pointer_Mapping;  
    Get_Pointer_Mapping        : constant Xrc := R3.Get_Pointer_Mapping;  
    Set_Modifier_Mapping       : constant Xrc := R3.Set_Modifier_Mapping;  
    Get_Modifier_Mapping       : constant Xrc := R3.Get_Modifier_Mapping;  
    No_Operation               : constant Xrc := R3.No_Operation;  

    None_X_Request_Code : X_Request_Code renames R3.None_X_Request_Code;  

--
------------------------------------------------------------------------------  
-- X Protocol Requests - Only the names are visible.  This makes compilation  
-- much much faster for modules that do not require the default Ada operations,  
-- e.g. "=".  
------------------------------------------------------------------------------  

    subtype X_Alloc_Color_Request          is R3.X_Alloc_Color_Request;  
    subtype X_Alloc_Color_Cells_Request    is R3.X_Alloc_Color_Cells_Request;  
    subtype X_Alloc_Color_Planes_Request   is R3.X_Alloc_Color_Planes_Request;  
    subtype X_Alloc_Named_Color_Request    is R3.X_Alloc_Named_Color_Request;  
    subtype X_Allow_Events_Request         is R3.X_Allow_Events_Request;  
    subtype X_Bell_Request                 is R3.X_Bell_Request;  
    subtype X_Change_Active_Pointer_Grab_Request  
        is R3.X_Change_Active_Pointer_Grab_Request;  
    subtype X_Change_Gc_Request            is R3.X_Change_Gc_Request;  
    subtype X_Change_Hosts_Request         is R3.X_Change_Hosts_Request;  
    subtype X_Change_Keyboard_Control_Request  
        is R3.X_Change_Keyboard_Control_Request;  
    subtype X_Change_Keyboard_Mapping_Request  
        is R3.X_Change_Keyboard_Mapping_Request;  
    subtype X_Change_Pointer_Control_Request  
        is R3.X_Change_Pointer_Control_Request;  
    subtype X_Change_Property_Request      is R3.X_Change_Property_Request;  
    subtype X_Change_Save_Set_Request      is R3.X_Change_Save_Set_Request;  
    subtype X_Change_Window_Attributes_Request  
        is R3.X_Change_Window_Attributes_Request;  
    subtype X_Circulate_Window_Request     is R3.X_Circulate_Window_Request;  
    subtype X_Clear_Area_Request           is R3.X_Clear_Area_Request;  
    subtype X_Close_Font_Request           is R3.X_Close_Font_Request;  
    subtype X_Configure_Window_Request     is R3.X_Configure_Window_Request;  
    subtype X_Convert_Selection_Request    is R3.X_Convert_Selection_Request;  
    subtype X_Copy_Area_Request            is R3.X_Copy_Area_Request;  
    subtype X_Copy_Colormap_And_Free_Request  
        is R3.X_Copy_Colormap_And_Free_Request;  
    subtype X_Copy_Gc_Request              is R3.X_Copy_Gc_Request;  
    subtype X_Copy_Plane_Request           is R3.X_Copy_Plane_Request;  
    subtype X_Create_Colormap_Request      is R3.X_Create_Colormap_Request;  
    subtype X_Create_Cursor_Request        is R3.X_Create_Cursor_Request;  
    subtype X_Create_Gc_Request            is R3.X_Create_Gc_Request;  
    subtype X_Create_Glyph_Cursor_Request  is R3.X_Create_Glyph_Cursor_Request;  
    subtype X_Create_Pixmap_Request        is R3.X_Create_Pixmap_Request;  
    subtype X_Create_Window_Request        is R3.X_Create_Window_Request;  
    subtype X_Delete_Property_Request      is R3.X_Delete_Property_Request;  
    subtype X_Destroy_Subwindows_Request   is R3.X_Destroy_Subwindows_Request;  
    subtype X_Destroy_Window_Request       is R3.X_Destroy_Window_Request;  
    subtype X_Fill_Poly_Request            is R3.X_Fill_Poly_Request;  
    subtype X_Force_Screen_Saver_Request   is R3.X_Force_Screen_Saver_Request;  
    subtype X_Free_Colormap_Request        is R3.X_Free_Colormap_Request;  
    subtype X_Free_Colors_Request          is R3.X_Free_Colors_Request;  
    subtype X_Free_Cursor_Request          is R3.X_Free_Cursor_Request;  
    subtype X_Free_Gc_Request              is R3.X_Free_Gc_Request;  
    subtype X_Free_Pixmap_Request          is R3.X_Free_Pixmap_Request;  
    subtype X_Get_Atom_Name_Request        is R3.X_Get_Atom_Name_Request;  
    subtype X_Get_Font_Path_Request        is R3.X_Get_Font_Path_Request;  
    subtype X_Get_Geometry_Request         is R3.X_Get_Geometry_Request;  
    subtype X_Get_Image_Request            is R3.X_Get_Image_Request;  
    subtype X_Get_Input_Focus_Request      is R3.X_Get_Input_Focus_Request;  
    subtype X_Get_Keyboard_Control_Request is R3.X_Get_Keyboard_Control_Request;  
    subtype X_Get_Keyboard_Mapping_Request is R3.X_Get_Keyboard_Mapping_Request;  
    subtype X_Get_Modifier_Mapping_Request is R3.X_Get_Modifier_Mapping_Request;  
    subtype X_Get_Motion_Events_Request    is R3.X_Get_Motion_Events_Request;  
    subtype X_Get_Pointer_Control_Request  is R3.X_Get_Pointer_Control_Request;  
    subtype X_Get_Pointer_Mapping_Request  is R3.X_Get_Pointer_Mapping_Request;  
    subtype X_Get_Property_Request         is R3.X_Get_Property_Request;  
    subtype X_Get_Screen_Saver_Request     is R3.X_Get_Screen_Saver_Request;  
    subtype X_Get_Selection_Owner_Request  is R3.X_Get_Selection_Owner_Request;  
    subtype X_Get_Window_Attributes_Request  
        is R3.X_Get_Window_Attributes_Request;  
    subtype X_Grab_Button_Request          is R3.X_Grab_Button_Request;  
    subtype X_Grab_Key_Request             is R3.X_Grab_Key_Request;  
    subtype X_Grab_Keyboard_Request        is R3.X_Grab_Keyboard_Request;  
    subtype X_Grab_Pointer_Request         is R3.X_Grab_Pointer_Request;  
    subtype X_Grab_Server_Request          is R3.X_Grab_Server_Request;  
    subtype X_Image_Text16_Request         is R3.X_Image_Text16_Request;  
    subtype X_Image_Text8_Request          is R3.X_Image_Text8_Request;  
    subtype X_Install_Colormap_Request     is R3.X_Install_Colormap_Request;  
    subtype X_Intern_Atom_Request          is R3.X_Intern_Atom_Request;  
    subtype X_Kill_Client_Request          is R3.X_Kill_Client_Request;  
    subtype X_List_Extensions_Request      is R3.X_List_Extensions_Request;  
    subtype X_List_Fonts_Request           is R3.X_List_Fonts_Request;  
    subtype X_List_Fonts_With_Info_Request is R3.X_List_Fonts_With_Info_Request;  
    subtype X_List_Hosts_Request           is R3.X_List_Hosts_Request;  
    subtype X_List_Installed_Colormaps_Request  
        is R3.X_List_Installed_Colormaps_Request;  
    subtype X_List_Properties_Request      is R3.X_List_Properties_Request;  
    subtype X_Lookup_Color_Request         is R3.X_Lookup_Color_Request;  
    subtype X_Map_Subwindows_Request       is R3.X_Map_Subwindows_Request;  
    subtype X_Map_Window_Request           is R3.X_Map_Window_Request;  
    subtype X_No_Operation_Request         is R3.X_No_Operation_Request;  
    subtype X_Open_Font_Request            is R3.X_Open_Font_Request;  
    subtype X_Poly_Arc_Request             is R3.X_Poly_Arc_Request;  
    subtype X_Poly_Fill_Arc_Request        is R3.X_Poly_Fill_Arc_Request;  
    subtype X_Poly_Fill_Rectangle_Request  is R3.X_Poly_Fill_Rectangle_Request;  
    subtype X_Poly_Line_Request            is R3.X_Poly_Line_Request;  
    subtype X_Poly_Point_Request           is R3.X_Poly_Point_Request;  
    subtype X_Poly_Rectangle_Request       is R3.X_Poly_Rectangle_Request;  
    subtype X_Poly_Segment_Request         is R3.X_Poly_Segment_Request;  
    subtype X_Poly_Text16_Request          is R3.X_Poly_Text16_Request;  
    subtype X_Poly_Text8_Request           is R3.X_Poly_Text8_Request;  
    subtype X_Put_Image_Request            is R3.X_Put_Image_Request;  
    subtype X_Query_Best_Size_Request      is R3.X_Query_Best_Size_Request;  
    subtype X_Query_Colors_Request         is R3.X_Query_Colors_Request;  
    subtype X_Query_Extension_Request      is R3.X_Query_Extension_Request;  
    subtype X_Query_Font_Request           is R3.X_Query_Font_Request;  
    subtype X_Query_Keymap_Request         is R3.X_Query_Keymap_Request;  
    subtype X_Query_Pointer_Request        is R3.X_Query_Pointer_Request;  
    subtype X_Query_Text_Extents_Request   is R3.X_Query_Text_Extents_Request;  
    subtype X_Query_Tree_Request           is R3.X_Query_Tree_Request;  
    subtype X_Recolor_Cursor_Request       is R3.X_Recolor_Cursor_Request;  
    subtype X_Reparent_Window_Request      is R3.X_Reparent_Window_Request;  
    subtype X_Rotate_Properties_Request    is R3.X_Rotate_Properties_Request;  
    subtype X_Send_Event_Request           is R3.X_Send_Event_Request;  
    subtype X_Set_Access_Control_Request   is R3.X_Set_Access_Control_Request;  
    subtype X_Set_Clip_Rectangles_Request  is R3.X_Set_Clip_Rectangles_Request;  
    subtype X_Set_Close_Down_Mode_Request  is R3.X_Set_Close_Down_Mode_Request;  
    subtype X_Set_Dashes_Request           is R3.X_Set_Dashes_Request;  
    subtype X_Set_Font_Path_Request        is R3.X_Set_Font_Path_Request;  
    subtype X_Set_Input_Focus_Request      is R3.X_Set_Input_Focus_Request;  
    subtype X_Set_Modifier_Mapping_Request is R3.X_Set_Modifier_Mapping_Request;  
    subtype X_Set_Pointer_Mapping_Request  is R3.X_Set_Pointer_Mapping_Request;  
    subtype X_Set_Screen_Saver_Request     is R3.X_Set_Screen_Saver_Request;  
    subtype X_Set_Selection_Owner_Request  is R3.X_Set_Selection_Owner_Request;  
    subtype X_Store_Colors_Request         is R3.X_Store_Colors_Request;  
    subtype X_Color_Item                   is R3.X_Color_Item;  
    subtype X_Store_Named_Color_Request    is R3.X_Store_Named_Color_Request;  
    subtype X_Translate_Coords_Request     is R3.X_Translate_Coords_Request;  
    subtype X_Ungrab_Button_Request        is R3.X_Ungrab_Button_Request;  
    subtype X_Ungrab_Key_Request           is R3.X_Ungrab_Key_Request;  
    subtype X_Ungrab_Keyboard_Request      is R3.X_Ungrab_Keyboard_Request;  
    subtype X_Ungrab_Pointer_Request       is R3.X_Ungrab_Pointer_Request;  
    subtype X_Ungrab_Server_Request        is R3.X_Ungrab_Server_Request;  
    subtype X_Uninstall_Colormap_Request   is R3.X_Uninstall_Colormap_Request;  
    subtype X_Unmap_Subwindows_Request     is R3.X_Unmap_Subwindows_Request;  
    subtype X_Unmap_Window_Request         is R3.X_Unmap_Window_Request;  
    subtype X_Warp_Pointer_Request         is R3.X_Warp_Pointer_Request;  

end Xlbt_Request;  

