with Xlbt_String;  
use Xlbt_String;  

with Xlbmt_Error_Log;  
use Xlbmt_Error_Log;  
with Xlbmp_Error_Log;  
use Xlbmp_Error_Log;  
with Xlbt_Proc_Var;  
use Xlbt_Proc_Var;  
with Xlbp_Proc_Var;  
use Xlbp_Proc_Var;  
with Xlbit_Library3;  
use Xlbit_Library3;  

package body Trap_Error_Reports is  
------------------------------------------------------------------------------  
-- Trap_Error_Reports - intercept any error reports generated and, if  
-- they are expected, simply note their existence.  Unexpected errors  
-- are propagated to the standard (default) error reporting mechanism.  
------------------------------------------------------------------------------  
-- 09/25/90 DRK     | Created.  
------------------------------------------------------------------------------  

    procedure Error_Report_Trap (Name1   : X_String;  
                                 Name2   : X_String;  
                                 Default : X_String;  
                                 Arg1    : X_String := "";  
                                 Arg2    : X_String := "";  
                                 Arg3    : X_String := "";  
                                 Arg4    : X_String := "";  
                                 Arg5    : X_String := "";  
                                 Arg6    : X_String := "";  
                                 Kind    : X_Report_Message_Kind) is  
        --  
        -- Control error reports using the package state variables.  
        -- An X_Report_Error procedure variable.  
        --  
    begin  
        if not Expect_Error_Report then  
            Default_X_Report_Error (Name1, Name2, Default, Arg1, Arg2,  
                                    Arg3, Arg4, Arg5, Arg6, Kind);  
        end if;  

        Error_Reported := True;  
    end Error_Report_Trap;  

    ----------------------------------------------------------------------  

    function Error_Report_Trap_Value is  
       new Proc_Var_X_Report_Error.Value (Error_Report_Trap);  


    procedure Catch_Error_Reports (Old : out X_Procedure_Variable) is  
        -- Install Error_Report_Trap as the current error reporting  
        -- mechanism.  Return the previous procedure value.  
    begin  
        X_Lib.Set_Report_Error  
           (Proc_Var_X_Report_Error.From_Pv (Error_Report_Trap_Value), Old);  
    end Catch_Error_Reports;  

    --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  --  

    procedure Propagate_Error_Reports (Old : X_Procedure_Variable) is  
        -- Uninstall the current error reporter, replacing it with the  
        -- Old value provided.  
        Ignore : X_Procedure_Variable;  
    begin  
        X_Lib.Set_Report_Error (Old, Ignore);  
    end Propagate_Error_Reports;  

end Trap_Error_Reports;  

