with Xlbt_Proc_Var;  
use Xlbt_Proc_Var;  

package Trap_Error_Reports is  
------------------------------------------------------------------------------  
-- X Library Testing  
--  
-- Trap_Error_Reports - intercept error reports.  
------------------------------------------------------------------------------  
-- Copyright 1990 - 1990 by Rational, Santa Clara, California.  
--  
--                  All Rights Reserved.  
--  
-- Permission to use, copy, modify, and distribute this software and its  
-- documentation for any purpose and without fee is hereby granted,  
-- provided that the above copyright notice(s) appear in all copies and that  
-- both that copyright notice(s) and this permission notice appear in  
-- supporting documentation, and that the name of Rational not be used in  
-- advertising or publicity pertaining to distribution of the software  
-- without specific, written prior permission.  
--  
-- Rational disclaims all warranties with regard to this software, including  
-- all implied warranties of merchantability and fitness, in no event shall  
-- Rational be liable for any special, indirect or consequential damages or  
-- any damages whatsoever resulting from loss of use, data or profits, whether  
-- in an action of contract, negligence or other tortious action, arising out  
-- of or in connection with the use or performance of this software.  
------------------------------------------------------------------------------  


    Expect_Error_Report : Boolean := False;  
    --  
    -- Set to True if a test is expected to report an error.  

    Error_Reported : Boolean := False;  
    --  
    -- Set if a test reports an error.  Should be reset by the  
    -- application.  


    procedure Catch_Error_Reports (Old : out X_Procedure_Variable);  
    --  
    -- Old      - returns the previous Report_Error procedure.  
    --  
    -- Install a special Report_Error procedure that uses the state  
    -- variables above.  This new error reporter will smother any  
    -- expected errors and invoke the Default_X_Report_Error procedure  
    -- for any unexpected errors.  Error_Reported will be set  
    -- regardless.  

    procedure Propagate_Error_Reports (Old : X_Procedure_Variable);  
    --  
    -- Old      - Specifies the previous Report_Error procedure  
    --  
    -- Remove the current Report_Error procedure and re-install Old.  

end Trap_Error_Reports;  

